'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _baseUrl = require('./baseUrl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

exports.default = {
  getDataForMedia: function getDataForMedia(token, mediaId) {
    var url = _baseUrl.baseUrl + '/media/' + mediaId;
    return _axios2.default.get(url, {
      headers: {
        Authorization: 'Bearer ' + token
      }
    }).then(function (response) {
      return response.data;
    }).catch(function (error) {
      if (error.data && error.data.errors) {
        throw error.data.errors.error;
      } else {
        throw error;
      }
    });
  },
  getMediaUrl: function getMediaUrl(token, mediaId) {
    var url = _baseUrl.baseUrl + '/media/' + mediaId + '/streams';
    return _axios2.default.get(url, {
      headers: {
        Authorization: 'Bearer ' + token
      }
    }).then(function (response) {
      var streamURL = null;
      if (response.data && response.data.streams) {
        // V3 has a different format...this code needs to be in a better spot...
        var streams = response.data.streams;
        if (streams.length) {
          // v3 - streams is Array<{streamName:string, steramLocation:string}>
          var sources = streams.reduce(function (returnObject, stream) {
            Object.assign(returnObject, _defineProperty({}, stream.streamName, stream.streamLocation));
            return returnObject;
          }, {});
          streamURL = sources.redacted || sources.original || streamURL;
        } else {
          // v2 - streams is string
          streamURL = streams.audio || streams.original || streamURL;
        }
      }

      return {
        url: streamURL,
        mediaId: mediaId
      };
    }).catch(function (error) {
      if (error.data && error.data.errors) {
        return Promise.reject(error.data.errors.error);
      }
      return Promise.reject(error);
    });
  }
};