'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Common = require('../common/Common');

var _withPlayer = require('./player/refactor/withPlayer');

var _withPlayer2 = _interopRequireDefault(_withPlayer);

var _PlayerUI = require('./player/refactor/PlayerUI');

var _PlayerUI2 = _interopRequireDefault(_PlayerUI);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var VoicebasePlayerApp = function (_React$Component) {
  _inherits(VoicebasePlayerApp, _React$Component);

  function VoicebasePlayerApp() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, VoicebasePlayerApp);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = VoicebasePlayerApp.__proto__ || Object.getPrototypeOf(VoicebasePlayerApp)).call.apply(_ref, [this].concat(args))), _this), _this.selectTab = function (key) {
      _this.props.actions.choosePlayerAppTab(key);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(VoicebasePlayerApp, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          mediaDataState = _props.mediaDataState,
          actions = _props.actions;

      var type = 'audio';
      if (mediaDataState.metadata.contentType) {
        type = (0, _Common.parseMediaType)(mediaDataState.metadata.contentType);
      }
      actions.createPlayer(mediaDataState.mediaUrl, type);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.props.actions.destroyPlayer();
      this.props.actions.removeMediaData();
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          playerState = _props2.playerState,
          mediaData = _props2.mediaDataState,
          markersState = _props2.markersState,
          viewTemplate = _props2.viewTemplate;


      return _react2.default.createElement(
        'div',
        null,
        _react2.default.createElement(_PlayerUI2.default, { viewTemplate: viewTemplate, playerState: playerState, mediaData: mediaData, markersState: markersState })
      );
    }
  }]);

  return VoicebasePlayerApp;
}(_react2.default.Component);

VoicebasePlayerApp.propTypes = {
  viewTemplate: _propTypes2.default.string,
  mediaDataState: _propTypes2.default.object.isRequired,
  playerState: _propTypes2.default.object.isRequired,
  markersState: _propTypes2.default.object,
  actions: _propTypes2.default.object.isRequired
};
exports.default = (0, _withPlayer2.default)()(VoicebasePlayerApp);