'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _root = require('../redux/root');

var _search = require('../redux/modules/search');

var _VoicebasePlayerApp = require('./VoicebasePlayerApp');

var _VoicebasePlayerApp2 = _interopRequireDefault(_VoicebasePlayerApp);

var _analyticsParser = require('../utilities/analytics-parser');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    playerState: state.player.toJS(),
    mediaDataState: state.mediaData.toJS(),
    markersState: state.markers.toJS()
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)(_root.rootActions, dispatch),
    setSearchIdentifiedRanges: (0, _redux.bindActionCreators)(_search.setSearchIdentifiedRanges, dispatch)
  };
};

var VoicebasePlayerCore = function (_React$Component) {
  _inherits(VoicebasePlayerCore, _React$Component);

  function VoicebasePlayerCore(props) {
    _classCallCheck(this, VoicebasePlayerCore);

    var _this = _possibleConstructorReturn(this, (VoicebasePlayerCore.__proto__ || Object.getPrototypeOf(VoicebasePlayerCore)).call(this, props));

    _this.instance = document.createElement('VIDEO');
    _this.instance.width = 480;
    return _this;
  }

  _createClass(VoicebasePlayerCore, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          analytics = _props.analytics,
          analyticsFormat = _props.analyticsFormat,
          mediaUrl = _props.mediaUrl,
          actions = _props.actions;

      actions.setMediaUrl(mediaUrl);
      actions.setAnalytics(analyticsFormat, analytics);
      if (this.props.searchTimeRanges.length) this.updateSearchRanges(this.props.searchTimeRanges);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props2 = this.props,
          analytics = _props2.analytics,
          analyticsFormat = _props2.analyticsFormat,
          mediaUrl = _props2.mediaUrl,
          actions = _props2.actions;


      if (mediaUrl !== nextProps.mediaUrl) {
        actions.setMediaUrl(mediaUrl);
      }

      if (analyticsFormat !== nextProps.analyticsFormat || analytics !== nextProps.analytics) {
        actions.setAnalytics(nextProps.analyticsFormat, nextProps.analytics);
      }
    }
  }, {
    key: 'updateSearchRanges',
    value: function updateSearchRanges(searchTimeRanges) {
      var searchTimeRangesObject = searchTimeRanges;
      // If the searchTimeRangesObject is a string, try and convert it, otherwise ignore...
      if (typeof searchTimeRangesObject === 'string') {
        try {
          searchTimeRangesObject = JSON.parse(searchTimeRanges);
        } catch (error) {
          // String is not JSON, ignore it...
          searchTimeRangesObject = [];
        }
      }
      this.props.setSearchIdentifiedRanges(searchTimeRangesObject);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          viewTemplate = _props3.viewTemplate,
          playerState = _props3.playerState,
          mediaDataState = _props3.mediaDataState,
          markersState = _props3.markersState,
          actions = _props3.actions,
          rest = _objectWithoutProperties(_props3, ['viewTemplate', 'playerState', 'mediaDataState', 'markersState', 'actions']);

      return _react2.default.createElement(
        'div',
        null,
        mediaDataState.analyticsLoaded && mediaDataState.mediaUrlLoaded && _react2.default.createElement(_VoicebasePlayerApp2.default, _extends({
          viewTemplate: viewTemplate,
          playerState: playerState,
          mediaDataState: mediaDataState,
          markersState: markersState,
          actions: actions,
          instance: this.instance
        }, rest))
      );
    }
  }]);

  return VoicebasePlayerCore;
}(_react2.default.Component);

VoicebasePlayerCore.propTypes = {

  /**
   * Input Props (externally sourced data)
   */
  viewTemplate: _propTypes2.default.string,
  analytics: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]).isRequired,
  analyticsFormat: _propTypes2.default.oneOf(_analyticsParser.AVAILABLE_ANALYTICS_SCHEMAS).isRequired,
  mediaUrl: _propTypes2.default.string.isRequired,
  // TODO: We need to be able to use logic to deal with input. This needs to live in
  // the App component which should look after the player logic. At the moment, we assume
  // that the searchTimeRanges being passed in from external sources is in the correct
  // format, but searchTerm won't currently work as we need the analytics in the correct,
  // parsed format. These need to move to the app component.
  searchTimeRanges: _propTypes2.default.oneOfType([_propTypes2.default.arrayOf(_propTypes2.default.shape({
    startTime: _propTypes2.default.number.isRequired,
    endTime: _propTypes2.default.number.isRequired
  })), _propTypes2.default.string]),
  // searchTerm: PropTypes.string,

  /**
   * Mapped Props (mapping from our internal data)
   */
  // TODO: The flow of how data is passed between components in the entire player
  // needs to be reworked. For now, we'll ignore that we can't define the actual shape of
  // the player store in one entire block, that this component has knowledge of the entire
  // store, and that other components are not mapping their state from the store and
  // instead being passed everything down from this component.
  // eslint-disable-next-line react/forbid-prop-types
  playerState: _propTypes2.default.object.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  mediaDataState: _propTypes2.default.object.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  markersState: _propTypes2.default.object.isRequired,

  /**
   * Mapped Actions
   */
  setSearchIdentifiedRanges: _propTypes2.default.func.isRequired,
  // TODO: We SHOULD NOT be passing ALL actions as props. We should be mapping them where needed.
  // eslint-disable-next-line react/forbid-prop-types
  actions: _propTypes2.default.object.isRequired
};
VoicebasePlayerCore.defaultProps = {
  analyticsFormat: _analyticsParser.ANALYTICS_SCHEMA_VERSION_V3,
  searchTimeRanges: []
  // searchTerm: '',
};
exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(VoicebasePlayerCore);