'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var Spinner = function Spinner(props) {
  var isSmallItem = props.isSmallItem,
      isMediumItem = props.isMediumItem;


  var classes = (0, _classnames2.default)('spinner', {
    'item-medium': isMediumItem,
    'item-small': isSmallItem
  });

  return _react2.default.createElement(
    'div',
    { className: classes },
    _react2.default.createElement('div', { className: 'rect1' }),
    _react2.default.createElement('div', { className: 'rect2' }),
    _react2.default.createElement('div', { className: 'rect3' }),
    _react2.default.createElement('div', { className: 'rect4' }),
    _react2.default.createElement('div', { className: 'rect5' })
  );
};

Spinner.propTypes = {
  isSmallItem: _propTypes2.default.bool,
  isMediumItem: _propTypes2.default.bool
};

Spinner.defaultProps = {
  isSmallItem: false,
  isMediumItem: false
};

exports.default = Spinner;