'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VoicebasePlayerCore = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _root = require('../../redux/root');

var _VoicebasePlayerApp = require('../VoicebasePlayerApp');

var _VoicebasePlayerApp2 = _interopRequireDefault(_VoicebasePlayerApp);

var _analyticsParser = require('../../redux/utils/analytics-parser');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    playerState: state.player.toJS(),
    mediaDataState: state.mediaData.toJS(),
    markersState: state.markers.toJS()
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    actions: (0, _redux.bindActionCreators)(_root.rootActions, dispatch)
  };
};

var VoicebasePlayerCore = exports.VoicebasePlayerCore = function (_React$Component) {
  _inherits(VoicebasePlayerCore, _React$Component);

  function VoicebasePlayerCore() {
    _classCallCheck(this, VoicebasePlayerCore);

    return _possibleConstructorReturn(this, (VoicebasePlayerCore.__proto__ || Object.getPrototypeOf(VoicebasePlayerCore)).apply(this, arguments));
  }

  _createClass(VoicebasePlayerCore, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props = this.props,
          analytics = _props.analytics,
          analyticsFormat = _props.analyticsFormat,
          mediaUrl = _props.mediaUrl,
          searchString = _props.searchString,
          actions = _props.actions;

      if (mediaUrl !== nextProps.mediaUrl) {
        actions.setMediaUrl(mediaUrl);
      }
      // TODO: setAnalytics should not be concerned with searchString...
      // Search markers should be handled separately.
      if (analyticsFormat !== nextProps.analyticsFormat || analytics !== nextProps.analytics || searchString !== nextProps.searchString) {
        actions.setAnalytics(nextProps.analyticsFormat, nextProps.analytics, nextProps.searchString);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          playerState = _props2.playerState,
          mediaDataState = _props2.mediaDataState,
          markersState = _props2.markersState,
          actions = _props2.actions;

      return _react2.default.createElement(
        'div',
        null,
        mediaDataState.analyticsLoaded && mediaDataState.mediaUrlLoaded && _react2.default.createElement(_VoicebasePlayerApp2.default, {
          playerState: playerState,
          mediaDataState: mediaDataState,
          markersState: markersState,
          actions: actions
        })
      );
    }
  }]);

  return VoicebasePlayerCore;
}(_react2.default.Component);

VoicebasePlayerCore.propTypes = {
  // Input Props
  analytics: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]).isRequired,
  analyticsFormat: _propTypes2.default.oneOf(_analyticsParser.AVAILABLE_ANALYTICS_SCHEMAS).isRequired,
  mediaUrl: _propTypes2.default.string.isRequired,
  searchString: _propTypes2.default.string,

  // Mapped Props
  // TODO: The flow of how data is passed between components in the entire player
  // needs to be reworked. For now, we'll ignore that we can't define the actual shape of
  // the player store in one entire block, that this component has knowledge of the entire
  // store, and that other components are not mapping their state from the store and
  // instead being passed everything down from this component.
  // eslint-disable-next-line react/forbid-prop-types
  playerState: _propTypes2.default.object.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  mediaDataState: _propTypes2.default.object.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  markersState: _propTypes2.default.object.isRequired,
  // eslint-disable-next-line react/forbid-prop-types
  actions: _propTypes2.default.object.isRequired
};
VoicebasePlayerCore.defaultProps = {
  analyticsFormat: _analyticsParser.ANALYTICS_SCHEMA_VERSION_V3,
  searchString: ''
};
exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(VoicebasePlayerCore);