'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IntegratedPlatformApiPlayer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _platformApiData = require('../../redux/modules/platformApiData');

var _analyticsParser = require('../../redux/utils/analytics-parser');

var _VoicebasePlayerCore = require('../core/VoicebasePlayerCore');

var _VoicebasePlayerCore2 = _interopRequireDefault(_VoicebasePlayerCore);

var _Spinner = require('../common/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _baseUrl = require('../../api/baseUrl');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state) {
  var platformApiData = state.platformApiData.toJS() || {};
  return {
    analytics: platformApiData.analytics,
    mediaUrl: platformApiData.mediaUrl,
    getAnalyticsPending: platformApiData.getAnalyticsPending,
    getAnalyticsError: platformApiData.getAnalyticsError,
    getMediaUrlPending: platformApiData.getMediaUrlPending,
    getMediaUrlError: platformApiData.getMediaUrlError
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    getPlatformApiMediaUrl: (0, _redux.bindActionCreators)(_platformApiData.getPlatformApiMediaUrl, dispatch),
    getPlatformApiAnalytics: (0, _redux.bindActionCreators)(_platformApiData.getPlatformApiAnalytics, dispatch)
  };
};

var IntegratedPlatformApiPlayer = exports.IntegratedPlatformApiPlayer = function (_React$Component) {
  _inherits(IntegratedPlatformApiPlayer, _React$Component);

  function IntegratedPlatformApiPlayer() {
    _classCallCheck(this, IntegratedPlatformApiPlayer);

    return _possibleConstructorReturn(this, (IntegratedPlatformApiPlayer.__proto__ || Object.getPrototypeOf(IntegratedPlatformApiPlayer)).apply(this, arguments));
  }

  _createClass(IntegratedPlatformApiPlayer, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          token = _props.token,
          mediaId = _props.mediaId,
          apiUrl = _props.apiUrl,
          getPlatformApiMediaUrl = _props.getPlatformApiMediaUrl,
          getPlatformApiAnalytics = _props.getPlatformApiAnalytics;

      (0, _baseUrl.setBaseUrl)(apiUrl);
      getPlatformApiMediaUrl(token, mediaId);
      getPlatformApiAnalytics(token, mediaId);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props2 = this.props,
          getAnalyticsPending = _props2.getAnalyticsPending,
          getMediaUrlPending = _props2.getMediaUrlPending,
          analytics = _props2.analytics,
          mediaUrl = _props2.mediaUrl,
          analyticsFormat = _props2.analyticsFormat,
          searchString = _props2.searchString;
      // TODO: add states for errors or communicate to parent

      return _react2.default.createElement(
        'div',
        null,
        !getAnalyticsPending && !getMediaUrlPending ? _react2.default.createElement(_VoicebasePlayerCore2.default, {
          analytics: analytics,
          mediaUrl: mediaUrl,
          analyticsFormat: analyticsFormat,
          searchString: searchString
        }) : _react2.default.createElement(
          'div',
          { className: 'spinner-media_item' },
          _react2.default.createElement(_Spinner2.default, null)
        )
      );
    }
  }]);

  return IntegratedPlatformApiPlayer;
}(_react2.default.Component);

IntegratedPlatformApiPlayer.propTypes = {
  // Input Props
  token: _propTypes2.default.string.isRequired,
  mediaId: _propTypes2.default.string.isRequired,
  apiUrl: _propTypes2.default.string,
  analyticsFormat: _propTypes2.default.oneOf(_analyticsParser.AVAILABLE_ANALYTICS_SCHEMAS).isRequired,
  searchString: _propTypes2.default.string,

  // Mapped
  analytics: _propTypes2.default.object,
  mediaUrl: _propTypes2.default.string,
  getAnalyticsPending: _propTypes2.default.bool,
  getMediaUrlPending: _propTypes2.default.bool,
  // TODO: Use these for errors in render or to communicate to parent
  // getAnalyticsError: PropTypes.objects,
  // getMediaUrlError: PropTypes.objects,
  getPlatformApiMediaUrl: _propTypes2.default.func,
  getPlatformApiAnalytics: _propTypes2.default.func
};
IntegratedPlatformApiPlayer.defaultProps = {
  apiUrl: 'https://apis.voicebase.com/v3',
  analyticsFormat: _analyticsParser.ANALYTICS_SCHEMA_VERSION_V3
};
exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(IntegratedPlatformApiPlayer);