'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.StandaloneUrlPlayer = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _root = require('../../redux/root');

var _configureStore = require('../../redux/configureStore');

var _configureStore2 = _interopRequireDefault(_configureStore);

var _IntegratedUrlPlayer = require('./IntegratedUrlPlayer');

var _IntegratedUrlPlayer2 = _interopRequireDefault(_IntegratedUrlPlayer);

var _analyticsParser = require('../../redux/utils/analytics-parser');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var StandaloneUrlPlayer = exports.StandaloneUrlPlayer = function (_React$Component) {
  _inherits(StandaloneUrlPlayer, _React$Component);

  function StandaloneUrlPlayer(props) {
    _classCallCheck(this, StandaloneUrlPlayer);

    var _this = _possibleConstructorReturn(this, (StandaloneUrlPlayer.__proto__ || Object.getPrototypeOf(StandaloneUrlPlayer)).call(this, props));

    _this.store = (0, _configureStore2.default)({}, _root.rootReducers);
    return _this;
  }

  _createClass(StandaloneUrlPlayer, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          analyticsUrl = _props.analyticsUrl,
          analyticsFormat = _props.analyticsFormat,
          mediaUrl = _props.mediaUrl,
          searchString = _props.searchString;

      return _react2.default.createElement(
        _reactRedux.Provider,
        { store: this.store },
        _react2.default.createElement(
          'div',
          null,
          _react2.default.createElement(_IntegratedUrlPlayer2.default, {
            analyticsUrl: analyticsUrl,
            analyticsFormat: analyticsFormat,
            mediaUrl: mediaUrl,
            searchString: searchString
          })
        )
      );
    }
  }]);

  return StandaloneUrlPlayer;
}(_react2.default.Component);

StandaloneUrlPlayer.propTypes = {
  // Input Props
  analyticsUrl: _propTypes2.default.string.isRequired,
  analyticsFormat: _propTypes2.default.oneOf(_analyticsParser.AVAILABLE_ANALYTICS_SCHEMAS).isRequired,
  mediaUrl: _propTypes2.default.string.isRequired,
  searchString: _propTypes2.default.string
};
StandaloneUrlPlayer.defaultProps = {
  analyticsFormat: _analyticsParser.ANALYTICS_SCHEMA_VERSION_V3
};
exports.default = StandaloneUrlPlayer;