'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _DetectionListItem = require('./DetectionListItem');

var _DetectionListItem2 = _interopRequireDefault(_DetectionListItem);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var DetectionList = function (_React$Component) {
  _inherits(DetectionList, _React$Component);

  function DetectionList() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, DetectionList);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = DetectionList.__proto__ || Object.getPrototypeOf(DetectionList)).call.apply(_ref, [this].concat(args))), _this), _this.calcTimeOffset = function (time) {
      var timelineWidth = _this.props.playerState.timelineWidth;
      var duration = _this.props.playerState.duration;
      if (!duration) return 0;

      return time * timelineWidth / duration;
    }, _this.onClickMarker = function (time) {
      _this.props.actions.setUtteranceTime(time);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(DetectionList, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var utterances = this.props.utterances;
      var playerState = this.props.playerState;

      var timelineStyle = {
        width: playerState.timelineWidth + 'px'
      };

      return _react2.default.createElement(
        'div',
        { className: 'listing__detection' },
        utterances.itemIds.map(function (utterId) {
          var utterance = utterances.items[utterId];
          var labelStyle = {
            color: utterance.color
          };

          return _react2.default.createElement(
            'div',
            { key: 'utterance-item' + utterId, className: 'listing__detection__row blue' },
            _react2.default.createElement(
              'span',
              { className: 'listing__detection__label', style: labelStyle },
              utterance.name
            ),
            _react2.default.createElement(
              'div',
              { className: 'listing__detection__container', style: timelineStyle },
              utterance.segments.map(function (segment, i) {
                return _react2.default.createElement(_DetectionListItem2.default, {
                  key: 'utterance-marker-' + utterId + '-segment-' + i,
                  segment: segment,
                  color: utterance.color,
                  calcTimeOffset: _this2.calcTimeOffset,
                  onClickMarker: _this2.onClickMarker
                });
              })
            )
          );
        })
      );
    }
  }]);

  return DetectionList;
}(_react2.default.Component);

DetectionList.propTypes = {
  utterances: _propTypes2.default.object.isRequired,
  playerState: _propTypes2.default.object.isRequired,
  actions: _propTypes2.default.object.isRequired
};
exports.default = DetectionList;