'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactBootstrap = require('react-bootstrap');

var _KeywordTopic = require('./KeywordTopic');

var _KeywordTopic2 = _interopRequireDefault(_KeywordTopic);

var _KeywordWord = require('./KeywordWord');

var _KeywordWord2 = _interopRequireDefault(_KeywordWord);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Keywords = function (_React$Component) {
  _inherits(Keywords, _React$Component);

  function Keywords() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Keywords);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Keywords.__proto__ || Object.getPrototypeOf(Keywords)).call.apply(_ref, [this].concat(args))), _this), _this.setActiveTopic = function (topicId) {
      _this.props.actions.setActiveTopic(topicId, _this.props.type);
    }, _this.setMarkers = function (markers) {
      _this.props.actions.setMarkers(markers);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Keywords, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          topics = _props.topics,
          activeTopic = _props.activeTopic,
          activeSpeaker = _props.activeSpeaker;


      return _react2.default.createElement(
        'div',
        { className: 'listing__keywords' },
        _react2.default.createElement(
          _reactBootstrap.Row,
          null,
          _react2.default.createElement(
            _reactBootstrap.Col,
            { sm: 3, className: 'listing__keywords__topics__container' },
            _react2.default.createElement(
              'ul',
              { className: 'listing__keywords__topics' },
              topics.map(function (topic, index) {
                return _react2.default.createElement(_KeywordTopic2.default, {
                  key: 'topic-' + topic.name,
                  topicId: index,
                  topicName: topic.name,
                  isActive: activeTopic === index,
                  onClickTopic: _this2.setActiveTopic
                });
              })
            )
          ),
          _react2.default.createElement(
            _reactBootstrap.Col,
            { sm: 9, className: 'listing__keywords__container' },
            _react2.default.createElement(
              'ul',
              { className: 'listing__keywords-of-topic' },
              topics[activeTopic].keywords.map(function (keyword) {
                return _react2.default.createElement(_KeywordWord2.default, {
                  key: 'keyword-' + keyword.name,
                  keyword: keyword,
                  activeSpeakerId: activeSpeaker,
                  setMarkers: _this2.setMarkers
                });
              })
            )
          )
        )
      );
    }
  }]);

  return Keywords;
}(_react2.default.Component);

Keywords.propTypes = {
  type: _propTypes2.default.string.isRequired,
  activeSpeaker: _propTypes2.default.number.isRequired,
  activeTopic: _propTypes2.default.number.isRequired,
  topics: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    name: _propTypes2.default.string,
    type: _propTypes2.default.string,
    keywords: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      name: _propTypes2.default.string,
      internalName: _propTypes2.default.arrayOf(_propTypes2.default.string),
      score: _propTypes2.default.number
      // t: PropTypes.shape({
      //   // ???
      // }),
    })).isRequired,
    speakers: _propTypes2.default.arrayOf(_propTypes2.default.string)
  })).isRequired,
  actions: _propTypes2.default.object.isRequired
};
exports.default = Keywords;