'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _classnames = require('classnames');

var _classnames2 = _interopRequireDefault(_classnames);

var _VbsReactPlayer = require('./react-player/VbsReactPlayer');

var _VbsReactPlayer2 = _interopRequireDefault(_VbsReactPlayer);

var _reactBootstrap = require('react-bootstrap');

var _Spinner = require('../../components/common/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _VolumeSlider = require('./VolumeSlider');

var _VolumeSlider2 = _interopRequireDefault(_VolumeSlider);

var _PlayerSpeakers = require('./PlayerSpeakers');

var _PlayerSpeakers2 = _interopRequireDefault(_PlayerSpeakers);

var _Marker = require('./Marker');

var _Marker2 = _interopRequireDefault(_Marker);

var _Common = require('../../common/Common');

var _downloadFile = require('../../common/downloadFile');

var _downloadFile2 = _interopRequireDefault(_downloadFile);

var _MediaWrapper = require('./MediaWrapper');

var _MediaWrapper2 = _interopRequireDefault(_MediaWrapper);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Player = function (_React$Component) {
  _inherits(Player, _React$Component);

  function Player(props) {
    _classCallCheck(this, Player);

    var _this = _possibleConstructorReturn(this, (Player.__proto__ || Object.getPrototypeOf(Player)).call(this, props));

    _this.togglePlay = function () {
      _this.props.playerState.playing ? _this.onPause() : _this.onPlay();
    };

    _this.onDuration = function (e) {
      var duration = e.target.duration;
      if (duration && duration > 0 && _this.props.playerState.duration !== duration) {
        _this.props.actions.setDuration(duration);
      }
    };

    _this.onPlay = function () {
      _this.props.actions.play();
    };

    _this.onPause = function () {
      if (_this.props.playerState.loaded !== 0) {
        _this.props.actions.pause();
      }
    };

    _this.onProgress = function (e) {
      var played = e.target.currentTime / e.target.duration;
      var loaded = 1;

      if (played && _this.props.playerState.played !== played) {
        _this.props.actions.setPosition(played);
      }
      if (loaded && _this.props.playerState.loaded !== loaded) {
        _this.props.actions.setBuffered(loaded);
      }
    };

    _this.calcTimeOffset = function (time) {
      var timelineWidth = _this.refs.timeline && _this.refs.timeline.clientWidth || 0;
      var duration = _this.props.playerState.duration;
      if (!duration) return 0;

      return time * timelineWidth / duration;
    };

    _this.onSeekMouseDown = function (event) {
      var position = _this.calcPosition(event);
      _this.setState({
        seeking: true,
        seekValue: position
      });
    };

    _this.onSeekMouseMove = function (event) {
      if (!_this.state.seeking) {
        return false;
      }
      var position = _this.calcPosition(event);
      _this.setState({
        seekValue: position
      });
    };

    _this.onSeekMouseUp = function (event) {
      _this.setState({ seeking: false });
      var position = _this.calcPosition(event);
      _this.seekOnPosition(position);
    };

    _this.onSeekMarker = function (markerTime) {
      var duration = _this.props.playerState.duration;
      var position = duration ? markerTime / duration : 0;
      _this.seekOnPosition(position);
    };

    _this.seekToNextMarker = function () {
      var isLastMarker = true;
      var markersState = _this.props.markersState;
      var _iteratorNormalCompletion = true;
      var _didIteratorError = false;
      var _iteratorError = undefined;

      try {
        for (var _iterator = markersState.markerIds[Symbol.iterator](), _step; !(_iteratorNormalCompletion = (_step = _iterator.next()).done); _iteratorNormalCompletion = true) {
          var markerId = _step.value;

          var marker = markersState.markers[markerId];
          var ONE_SECOND = 1;
          var markerPosition = (marker.time - ONE_SECOND) / _this.props.playerState.duration;
          if (markerPosition > _this.props.playerState.played) {
            _this.seekOnPosition(markerPosition);
            isLastMarker = false;
            return false;
          }
        }
      } catch (err) {
        _didIteratorError = true;
        _iteratorError = err;
      } finally {
        try {
          if (!_iteratorNormalCompletion && _iterator.return) {
            _iterator.return();
          }
        } finally {
          if (_didIteratorError) {
            throw _iteratorError;
          }
        }
      }

      if (isLastMarker) {
        var firstMarker = markersState.markers[markersState.markerIds[0]];
        _this.onSeekMarker(firstMarker.time);
      }
    };

    _this.onVolumeChange = function (value) {
      _this.setState({
        volume: value
      });
    };

    _this.fullscreenPlayer = function () {
      _this.props.actions.setFullscreen(true);
    };

    _this.exitFullscreen = function () {
      _this.props.actions.setFullscreen(false);
      setTimeout(function () {
        return _this.forceUpdate();
      }, 100); // for re-rendering markers
    };

    _this.download = function () {
      var playerState = _this.props.playerState;

      (0, _downloadFile2.default)(playerState.url);
    };

    _this.state = { // moving slider; state is faster than redux
      seeking: false,
      seekValue: 0,
      volume: 100
    };
    return _this;
  }

  _createClass(Player, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var media = this.props.mediaState;
      if (!media) {
        return false;
      }
      var duration = 0;
      if (media.metadata && media.metadata.length && media.metadata.length.milliseconds) {
        duration = media.metadata.length.milliseconds / 1000;
      }
      if (duration) {
        this.onDuration(duration);
      }
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      var markersState = this.props.markersState;
      if (markersState && markersState.justCreated) {
        this.seekToFirstMarker(markersState);
      }
      // save timeline width for player
      var playerState = this.props.playerState;
      if (playerState && !playerState.timelineWidth && this.refs.timeline && this.refs.timeline.clientWidth) {
        this.props.actions.setTimelineWidth(this.refs.timeline.clientWidth);
      }
      // move to actve utterance
      if (playerState && playerState.utteranceTime !== null) {
        this.seekToUtterance(playerState.utteranceTime);
      }
    }
  }, {
    key: 'calcPosition',
    value: function calcPosition(event) {
      var timelineLeftOffset = this.refs.timeline.getBoundingClientRect().left;
      var clickLeftOffset = event.pageX;
      var timelineWidth = event.currentTarget.clientWidth;
      return (clickLeftOffset - timelineLeftOffset) / timelineWidth;
    }
  }, {
    key: 'seekToFirstMarker',
    value: function seekToFirstMarker(markersState) {
      var _this2 = this;

      var firstMarker = markersState.markers[markersState.markerIds[0]];
      this.props.actions.clearJustCreatedMarkers();
      setTimeout(function () {
        _this2.onSeekMarker(firstMarker.time);
      }, 100);
    }
  }, {
    key: 'seekToUtterance',
    value: function seekToUtterance(time) {
      var _this3 = this;

      this.props.actions.clearUtteranceTime();
      setTimeout(function () {
        _this3.onSeekMarker(time);
      }, 0);
    }

    /*
    * position is a percent value / 100
    * */

  }, {
    key: 'seekOnPosition',
    value: function seekOnPosition(position) {
      this.playerRef.currentTime = parseFloat(position) * (isNaN(this.playerRef.duration) ? 0 : this.playerRef.duration);
      this.props.actions.setPosition(position);
    }
  }, {
    key: 'getSlider',
    value: function getSlider() {
      var id = 'volume-slider' + Date.now();
      return _react2.default.createElement(
        _reactBootstrap.Popover,
        { id: id, className: 'volume-slider' },
        _react2.default.createElement(_VolumeSlider2.default, {
          orientation: 'vertical',
          value: this.state.volume,
          onChange: this.onVolumeChange
        })
      );
    }
  }, {
    key: 'getMarkers',
    value: function getMarkers() {
      var _this4 = this;

      var markersState = this.props.markersState;
      if (!markersState) return null;

      return markersState.markerIds.map(function (markerId) {
        var marker = markersState.markers[markerId];
        return _react2.default.createElement(_Marker2.default, {
          key: 'marker-' + markerId,
          marker: marker,
          calcTimeOffset: _this4.calcTimeOffset,
          onSeekMarker: _this4.onSeekMarker
        });
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _this5 = this;

      var playerState = this.props.playerState;
      if (!playerState || playerState.loading) {
        return _react2.default.createElement(
          'div',
          { className: 'vbs-player' },
          _react2.default.createElement(_Spinner2.default, null)
        );
      }

      var playerClases = (0, _classnames2.default)('vbs-player', {
        'vbs-player--video': playerState.type === 'video',
        'vbs-player--fullscreen': playerState.isFullscreen
      });

      var playerOriginalClasses = (0, _classnames2.default)('vbs-player__original', {
        'vbs-player__original--video': playerState.type === 'video',
        'vbs-player__original--audio': playerState.type === 'audio'
      });

      var mediaState = this.props.mediaState;
      var duration = this.props.playerState.duration;
      var timePercentValue = !this.state.seeking ? playerState.played : this.state.seekValue;
      var sliderValue = timePercentValue * 100;
      var sliderStyles = { left: sliderValue + '%' };
      var progressStyles = { width: sliderValue + '%' };
      var bufferStyles = { width: playerState.loaded * 100 + '%' };

      var parsedDuration = duration ? (0, _Common.parseTime)(duration) : '--:--';
      var parsedPlayedTime = (0, _Common.parseTime)(duration * timePercentValue);

      var volume = this.props.playerType === 'JwPlayer' ? this.state.volume : this.state.volume / 100;

      var speakers = null;
      var transcriptSpeakers = null;
      if (mediaState) {
        if (mediaState.transcriptSpeakers.length > 0) {
          speakers = mediaState.speakers;
          transcriptSpeakers = mediaState.transcriptSpeakers;
        }
      }

      var hasMarkers = this.props.markersState && this.props.markersState.markerIds && this.props.markersState.markerIds.length > 0;
      var isLoaded = playerState.loaded === 0;

      return _react2.default.createElement(
        'div',
        { className: playerClases },
        _react2.default.createElement(
          'div',
          { className: playerOriginalClasses },
          _react2.default.createElement(_MediaWrapper2.default, {
            playerRef: function playerRef(ref) {
              _this5.playerRef = ref;
            },
            src: playerState.url,
            playing: playerState.playing,
            volume: volume,
            onPlay: this.onPlay,
            onTimeUpdate: this.onProgress,
            onEnded: this.onPause,
            onDurationChange: this.onDuration
          }),
          playerState.type === 'video' && !playerState.isFullscreen && _react2.default.createElement(
            'a',
            { href: '#', className: 'vbs-player__original__fullscreen-btn', onClick: this.fullscreenPlayer },
            _react2.default.createElement('i', { className: 'fa fa-arrows-alt' })
          )
        ),
        _react2.default.createElement(
          'div',
          { style: { display: 'flex', padding: '0 10px', alignItems: 'center' } },
          _react2.default.createElement(
            'div',
            null,
            _react2.default.createElement(
              _reactBootstrap.ButtonGroup,
              { className: 'player__buttons' },
              _react2.default.createElement(
                _reactBootstrap.Button,
                { bsStyle: 'primary', onClick: this.togglePlay },
                playerState.playing && isLoaded && _react2.default.createElement('i', { className: 'fa fa-fw fa-circle-o-notch fa-spin' }),
                playerState.playing && !isLoaded && _react2.default.createElement('i', { className: 'fa fa-fw fa-pause' }),
                !playerState.playing && _react2.default.createElement('i', { className: 'fa fa-fw fa-play' })
              ),
              this.props.hasNextKeywordButton && _react2.default.createElement(
                _reactBootstrap.Button,
                { onClick: this.seekToNextMarker, disabled: !hasMarkers },
                _react2.default.createElement('i', { className: 'fa fa-fw fa-play fa-rotate-270' }),
                _react2.default.createElement('i', { className: 'fa fa-share fa-topleft' })
              )
            )
          ),
          _react2.default.createElement('div', { style: { padding: '10px', flexGrow: '1' } })
        )
      );
    }
  }]);

  return Player;
}(_react2.default.Component);

Player.propTypes = {
  playerType: _propTypes2.default.string.isRequired,
  mediaState: _propTypes2.default.object,
  markersState: _propTypes2.default.object,
  playerState: _propTypes2.default.object.isRequired,
  hasNextKeywordButton: _propTypes2.default.bool.isRequired,
  hasDownloadButton: _propTypes2.default.bool.isRequired,
  isShowKeywordsMarkers: _propTypes2.default.bool.isRequired,
  actions: _propTypes2.default.object.isRequired
};
exports.default = Player;

/*
        <div style={{ display: 'flex', padding: '0 10px', alignItems: 'center' }}>
          <div>
            <ButtonGroup className="player__buttons">
              <Button bsStyle="primary" onClick={this.togglePlay}>
                {playerState.playing && isLoaded && <i className="fa fa-fw fa-circle-o-notch fa-spin" />}
                {playerState.playing && !isLoaded && <i className="fa fa-fw fa-pause" />}
                {!playerState.playing && <i className="fa fa-fw fa-play" />}
              </Button>
              {this.props.hasNextKeywordButton &&
              <Button onClick={this.seekToNextMarker} disabled={!hasMarkers} >
                <i className="fa fa-fw fa-play fa-rotate-270" />
                <i className="fa fa-share fa-topleft" />
              </Button>
              }
            </ButtonGroup>
          </div>
          <div style={{ padding: '10px', flexGrow: '1' }}>
            <Timeline />
          </div>
        </div>
        <div style={{ display: 'flex', padding: '0 10px', alignItems: 'center' }}>
          <div style={{flexGrow: '1'}}>
            <ButtonGroup className="player__buttons">
              <Button bsStyle="primary" onClick={this.togglePlay}>
                {playerState.playing && isLoaded && <i className="fa fa-fw fa-circle-o-notch fa-spin" />}
                {playerState.playing && !isLoaded && <i className="fa fa-fw fa-pause" />}
                {!playerState.playing && <i className="fa fa-fw fa-play" />}
              </Button>
              {this.props.hasNextKeywordButton &&
              <Button onClick={this.seekToNextMarker} disabled={!hasMarkers} >
                <i className="fa fa-fw fa-play fa-rotate-270" />
                <i className="fa fa-share fa-topleft" />
              </Button>
              }
            </ButtonGroup>
          </div>
          <div style={{flexGrow: '1', textAlign: 'center' }}>
            {parsedPlayedTime} / {parsedDuration}
          </div>
          <div style={{flexGrow: '1', textAlign: 'right'}}>
            <ButtonGroup className="player__buttons">
              <OverlayTrigger trigger="click" placement={playerState.isFullscreen ? 'top' : 'bottom'} rootClose overlay={this.getSlider()}>
                <Button><i className="fa fa-fw fa-volume-up" /></Button>
              </OverlayTrigger>
              {this.props.hasDownloadButton && <Button onClick={this.download}><i className="fa fa-fw fa-cloud-download" /></Button>}
              {playerState.isFullscreen && <Button onClick={this.exitFullscreen}>Exit</Button>}
            </ButtonGroup>
          </div>
        </div>
      </div>
        */