'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PlayerDetection = function (_React$Component) {
  _inherits(PlayerDetection, _React$Component);

  function PlayerDetection() {
    _classCallCheck(this, PlayerDetection);

    return _possibleConstructorReturn(this, (PlayerDetection.__proto__ || Object.getPrototypeOf(PlayerDetection)).apply(this, arguments));
  }

  _createClass(PlayerDetection, [{
    key: 'onClickMarker',
    value: function onClickMarker(startSec) {
      this.props.onSeek(startSec);
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var utterances = this.props.utterances;
      return _react2.default.createElement(
        'div',
        { className: 'player__detection' },
        utterances.itemIds.map(function (utterId) {
          var utterance = utterances.items[utterId];

          return _react2.default.createElement(
            'div',
            { className: 'player__detection__row', key: 'utterance-marker-row' + utterId },
            utterance.segments.map(function (segment, i) {
              var start = _this2.props.calcTimeOffset(segment.s / 1000);
              var end = _this2.props.calcTimeOffset(segment.e / 1000);

              var segmentStyles = {
                left: start + 'px',
                width: end - start + 'px',
                backgroundColor: utterance.color
              };

              return _react2.default.createElement('a', { href: '#',
                key: 'utterance-marker-' + utterId + '-segment-' + i,
                className: 'player__detection__marker',
                style: segmentStyles,
                onClick: _this2.onClickMarker.bind(_this2, segment.s / 1000)
              });
            })
          );
        })
      );
    }
  }]);

  return PlayerDetection;
}(_react2.default.Component);

PlayerDetection.propTypes = {
  utterances: _propTypes2.default.object.isRequired,
  calcTimeOffset: _propTypes2.default.func.isRequired,
  onSeek: _propTypes2.default.func.isRequired
};
exports.default = PlayerDetection;