'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _antd = require('antd');

var _search = require('../../redux/modules/search');

var _search2 = require('../../utilities/search');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    currentInputTerm: state.search.currentInputTerm,
    words: state.mediaData.get('transcript').toJS()
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setSearchCurrentInputTerm: (0, _redux.bindActionCreators)(_search.setSearchCurrentInputTerm, dispatch),
    setSearchIdentifiedRanges: (0, _redux.bindActionCreators)(_search.setSearchIdentifiedRanges, dispatch)
  };
};

var SearchBar = function (_React$PureComponent) {
  _inherits(SearchBar, _React$PureComponent);

  function SearchBar() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, SearchBar);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = SearchBar.__proto__ || Object.getPrototypeOf(SearchBar)).call.apply(_ref, [this].concat(args))), _this), _this.searchLibrary = {}, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(SearchBar, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      this.searchLibrary = (0, _search2.createSearchWordLibraryFromWordsArray)(this.props.words);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      // TODO: Remove immutable from project...
      // We can't do the test on words because it returns a new list every time.
      // Working with a half implemented immutable library is a PITFA!!
      // if (this.props.words !== nextProps.words) {
      //   this.createSearchWordLibraryFromWordsArray();
      // }

      if (this.props.currentInputTerm !== nextProps.currentInputTerm) {
        if (nextProps.currentInputTerm.length > 2) {
          var identifiedRanges = (0, _search2.identifySearchTermRangesInSearchWordLibrary)(nextProps.currentInputTerm, this.searchLibrary);
          this.props.setSearchIdentifiedRanges(identifiedRanges);
        } else {
          this.props.setSearchIdentifiedRanges([]);
        }
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      return _react2.default.createElement(_antd.Input.Search, {
        placeholder: 'find words',
        value: this.props.currentInputTerm,
        onChange: function onChange(e) {
          return _this2.props.setSearchCurrentInputTerm(e.target.value);
        }
      });
    }
  }]);

  return SearchBar;
}(_react2.default.PureComponent);

SearchBar.propTypes = {
  currentInputTerm: _propTypes2.default.string.isRequired,
  words: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    m: _propTypes2.default.string, // meta?? This field is an additional discriminator
    w: _propTypes2.default.string, // word (or identifier for meta objects)
    s: _propTypes2.default.number.isRequired, // start
    e: _propTypes2.default.number.isRequired // end
    // p: PropTypes.number.isRequired, // position / index of word or event - We don't use this
    // c: PropTypes.number, // confidence - We don't care for it here
  })).isRequired,
  setSearchCurrentInputTerm: _propTypes2.default.func.isRequired,
  setSearchIdentifiedRanges: _propTypes2.default.func.isRequired
};
exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(SearchBar);