'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _antd = require('antd');

var _TabKeywordTopic = require('./TabKeywordTopic');

var _TabKeywordTopic2 = _interopRequireDefault(_TabKeywordTopic);

var _TabKeywordWord = require('./TabKeywordWord');

var _TabKeywordWord2 = _interopRequireDefault(_TabKeywordWord);

var _mediaData = require('../../redux/modules/mediaData');

var _markers = require('../../redux/modules/markers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    activeSpeaker: state.mediaData.activeSpeaker
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setActiveTopic: (0, _redux.bindActionCreators)(_mediaData.setActiveTopic, dispatch),
    setMarkers: (0, _redux.bindActionCreators)(_markers.setMarkers, dispatch)
  };
};

var Keywords = function (_React$Component) {
  _inherits(Keywords, _React$Component);

  function Keywords() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Keywords);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Keywords.__proto__ || Object.getPrototypeOf(Keywords)).call.apply(_ref, [this].concat(args))), _this), _this.setActiveTopic = function (topicId) {
      _this.props.setActiveTopic(topicId, _this.props.type);
    }, _this.setMarkers = function (markers) {
      _this.props.setMarkers(markers);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Keywords, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          topics = _props.topics,
          activeTopic = _props.activeTopic,
          activeSpeaker = _props.activeSpeaker;


      return _react2.default.createElement(
        'div',
        { className: 'listing__keywords' },
        _react2.default.createElement(
          _antd.Row,
          { type: 'flex' },
          _react2.default.createElement(
            _antd.Col,
            { span: 6, className: 'listing__keywords__topics__container' },
            _react2.default.createElement(
              'ul',
              { className: 'listing__keywords__topics' },
              topics.map(function (topic, index) {
                return _react2.default.createElement(_TabKeywordTopic2.default, {
                  key: 'topic-' + topic.name,
                  topicId: index,
                  topicName: topic.name,
                  isActive: activeTopic === index,
                  onClickTopic: _this2.setActiveTopic
                });
              })
            )
          ),
          _react2.default.createElement(
            _antd.Col,
            { span: 18, className: 'listing__keywords__container' },
            _react2.default.createElement(
              'ul',
              { className: 'listing__keywords-of-topic' },
              topics[activeTopic].keywords.map(function (keyword) {
                return _react2.default.createElement(_TabKeywordWord2.default, {
                  key: 'keyword-' + keyword.name,
                  keyword: keyword,
                  activeSpeakerId: activeSpeaker,
                  setMarkers: _this2.setMarkers
                });
              })
            )
          )
        )
      );
    }
  }]);

  return Keywords;
}(_react2.default.Component);

Keywords.propTypes = {
  /**
   * Input Props
   */
  type: _propTypes2.default.string.isRequired,
  activeTopic: _propTypes2.default.number.isRequired,
  topics: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    name: _propTypes2.default.string,
    type: _propTypes2.default.string,
    keywords: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      name: _propTypes2.default.string,
      internalName: _propTypes2.default.arrayOf(_propTypes2.default.string),
      score: _propTypes2.default.number
    })).isRequired,
    speakers: _propTypes2.default.arrayOf(_propTypes2.default.string)
  })).isRequired,

  /**
   * Mapped Props
   */
  activeSpeaker: _propTypes2.default.number,
  setActiveTopic: _propTypes2.default.func.isRequired,
  setMarkers: _propTypes2.default.func.isRequired
};
Keywords.defaultProps = {
  activeSpeaker: null
};
exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(Keywords);