'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepEqual = require('deep-equal');

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _antd = require('antd');

var _Common = require('../../common/Common');

var _connectToPlayer = require('./refactor/connectToPlayer');

var _connectToPlayer2 = _interopRequireDefault(_connectToPlayer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var HIGHLIGHT_BOUNDARY = 2;
// Returns the current time section
// (the multiple of the HIGHLIGHT_BOUNDARY that we're currently up to)
var calculateTimeSection = function calculateTimeSection(time) {
  return parseInt((time || 0) / HIGHLIGHT_BOUNDARY, 10);
};

var Transcript = function (_React$Component) {
  _inherits(Transcript, _React$Component);

  function Transcript(props) {
    _classCallCheck(this, Transcript);

    var _this = _possibleConstructorReturn(this, (Transcript.__proto__ || Object.getPrototypeOf(Transcript)).call(this, props));

    _this.lastTime = null;
    _this.isHoverTranscript = false;

    _this.onMouseEnterTranscript = function () {
      _this.isHoverTranscript = true;
    };

    _this.onMouseLeaveTranscript = function () {
      _this.isHoverTranscript = false;
    };

    _this.updateTranscriptRef = function (ref) {
      _this.transcriptRef = ref;
    };

    _this.state = {
      hoverUtterance: null,
      hoverKeyword: null
    };
    return _this;
  }

  _createClass(Transcript, [{
    key: 'shouldComponentUpdate',
    value: function shouldComponentUpdate(nextProps, nextState) {
      var time = this.lastTime;
      var nextTime = nextProps.currentTime;
      var isTimeChanged = calculateTimeSection(time) !== calculateTimeSection(nextTime);
      if (isTimeChanged) {
        this.lastTime = nextTime;
      }

      // Immutable much... :-/
      var isChangedState = !(0, _deepEqual2.default)(this.state, nextState);
      var isChangedMarkers = !(0, _deepEqual2.default)(this.props.markersState, nextProps.markersState);
      var isChangedTab = !(0, _deepEqual2.default)(this.props.activeTab, nextProps.activeTab);
      var isChangedRanges = !(0, _deepEqual2.default)(this.props.identifiedRanges, nextProps.identifiedRanges);

      return isTimeChanged || isChangedState || isChangedMarkers || isChangedTab || isChangedRanges;
    }
  }, {
    key: 'componentDidUpdate',
    value: function componentDidUpdate() {
      if (this.transcriptRef && !this.isHoverTranscript) {
        var firstCurrentSpan = this.transcriptRef.querySelector('.current');
        if (firstCurrentSpan && !this.props.paused) {
          var markerRect = firstCurrentSpan.getBoundingClientRect();
          var transcriptRect = this.transcriptRef.getBoundingClientRect();
          this.transcriptRef.scroll({
            top: this.transcriptRef.scrollTop + (markerRect.top - transcriptRect.top) - 20,
            left: 0,
            behavior: 'smooth'
          });
        }
      }
    }
  }, {
    key: 'getMarkers',
    value: function getMarkers() {
      var markersState = this.props.markersState;
      var markers = {};
      if (markersState) {
        markersState.markerIds.forEach(function (markerId) {
          var marker = markersState.markers[markerId];
          var startTime = marker.time.toFixed(2);
          markers[startTime] = marker;
        });
      }
      return markers;
    }
  }, {
    key: 'isNewSpeakerTurn',
    value: function isNewSpeakerTurn(wordTurn) {
      if (!wordTurn) {
        return false;
      }
      return wordTurn === 'turn';
    }
  }, {
    key: 'getSpeakersCount',
    value: function getSpeakersCount() {
      var speakers = this.props.speakers;
      speakers = speakers.filter(function (speaker) {
        return speaker !== 'unknown';
      });
      return speakers.length;
    }
  }, {
    key: 'isHoverUtterance',
    value: function isHoverUtterance(utterance) {
      return this.state.hoverUtterance && utterance.id === this.state.hoverUtterance.id && utterance.segmentIndex === this.state.hoverUtterance.segmentIndex;
    }
  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props = this.props,
          transcript = _props.transcript,
          currentTime = _props.currentTime,
          identifiedRanges = _props.identifiedRanges,
          __instance = _props.__instance;

      var time = currentTime;
      var bottomHighlightBound = calculateTimeSection(time) * HIGHLIGHT_BOUNDARY;
      var topHighlightBound = bottomHighlightBound + HIGHLIGHT_BOUNDARY;
      var speakerCount = this.getSpeakersCount();
      // Prepare markers highlight

      var getRequiredClassesForWord = function getRequiredClassesForWord(word) {
        var classes = [];

        var wordTimeInSec = word.s / 1000;

        // Apply current if required
        var isCurrent = wordTimeInSec >= bottomHighlightBound && wordTimeInSec <= topHighlightBound;
        if (isCurrent) classes.push('current');

        var isSearch = identifiedRanges.filter(function (_ref) {
          var startTime = _ref.startTime,
              endTime = _ref.endTime;
          return word.s >= startTime && word.e <= endTime;
        });

        if (isSearch.length) classes.push('search');

        // TODO: Apply highlight if required
        // NOTE: We have to take this legacy code out for now. Hover states should DEFINITELY
        // be handled css when we're talking about possible 10k words of transcript.
        // We CAN NOT redraw this element every time there is a change in hover state
        // nor can we attach enter and leave events on every element...

        // const wordStyle = {};
        // const findingKeyword = markers[wordTimeInSec.toFixed(2)];
        // let isFindingKeyword = false;
        // if (findingKeyword) {
        //   const phraseWords = this.checkPhrase(findingKeyword, transcript.words, wordIndex);
        //   endPhraseWords = Object.assign({}, endPhraseWords, phraseWords);
        // }
        //
        // if (endPhraseWords[wordPos]) {
        //   isFindingKeyword = true;
        //   const color = endPhraseWords[wordPos].color;
        //   if (
        //     this.state.hoverKeyword !== null &&
        //     endPhraseWords[wordPos].keywordId === this.state.hoverKeyword
        //   ) {
        //     wordStyle.color = '#fff';
        //     wordStyle.backgroundColor = color;
        //   } else {
        //     wordStyle.color = color;
        //   }
        // }

        // Utterances don't seem to have previously worked. Leaving out for now as well.
        // // highlight utterances phrase
        // let utterance = null;
        // if (activeTab === DETECTION_TAB) {
        //   utterance = this.findDetectionSegment(startTime);
        // }
        // if (utterance && !isNewSpeakerTurn) {
        //   if (this.isHoverUtterance(utterance)) {
        //     wordStyle.color = '#fff';
        //     wordStyle.backgroundColor = utterance.color;
        //   } else {
        //     wordStyle.color = utterance.color;
        //   }
        // }

        return classes.sort().join(' ');
      };

      // The following reducer creates an object following the below schema
      // turnsArray [
      //   {
      //     speaker: 'xxx',
      //     color: 'xxx',
      //     time: 'xxx',
      //     spans: [
      //       {
      //         words: 'xxx xxx xxx',
      //         classes: 'xxx xxx',
      //       },
      //     ]
      //   },
      //   ...
      // ]

      var turnsArray = transcript.reduce(function (returnArray, word, i, words) {
        var currentTurn = returnArray[returnArray.length - 1];
        var currentSpan = currentTurn.spans[currentTurn.spans.length - 1];

        // Is it a turn or a new word?
        if (_this2.isNewSpeakerTurn(word.m)) {
          // In the case the previous turn had no spans, remove it.
          if (!currentSpan) returnArray.pop();
          // Create a new object of type 'turn'
          returnArray.push({
            speaker: word.w,
            color: (0, _Common.getSpeakerColor)(word.w),
            time: word.s / 1000,
            spans: []
          });
        } else {
          // Firstly get the required classes for this word, the currentTurn and the currentSpan
          var requiredClasses = getRequiredClassesForWord(word);

          // If the classes on the current span is different to what is required, we
          // create a new span.
          if (!currentSpan || requiredClasses !== currentSpan.classes) {
            currentTurn.spans.push({
              words: word.w,
              classes: requiredClasses
            });
          } else {
            // Otherwise the currentSpan has the correct classes so we'll add the
            // current word to this span.
            // If we have a punctuation mark don't add a space, add one otherwise if not.
            currentSpan.words += word.m === 'punc' ? '' : ' ';
            // Add the word...
            currentSpan.words += word.w;
          }

          if (speakerCount <= 1 && word.m === 'punc' && words[i + 1]) {
            // Create a new object of type 'turn'
            returnArray.push({
              speaker: currentTurn.speaker,
              color: currentTurn.color,
              time: words[i + 1].s / 1000,
              spans: []
            });
          }
        }
        return returnArray;
      }, [{
        time: 0,
        spans: []
      }]);

      return _react2.default.createElement(
        'div',
        { className: 'listing__transcript scroll-shadow' },
        _react2.default.createElement(
          'div',
          {
            className: ' listing__transcript__content',
            ref: this.updateTranscriptRef,
            onMouseEnter: this.onMouseEnterTranscript,
            onMouseLeave: this.onMouseLeaveTranscript
          },
          _react2.default.createElement(
            _antd.Timeline,
            null,
            turnsArray.map(function (turn, i) {
              return _react2.default.createElement(
                _antd.Timeline.Item,
                { style: { padding: '0' }, key: i, color: turn.color },
                _react2.default.createElement(
                  'div',
                  { className: 'listing__transcript__turn' },
                  _react2.default.createElement(
                    'div',
                    { className: 'listing__transcript__speaker' },
                    turn.speaker && _react2.default.createElement(
                      'div',
                      { style: { color: turn.color } },
                      turn.speaker
                    ),
                    _react2.default.createElement(
                      'div',
                      {
                        className: 'listing__transcript__speaker-time',
                        style: { fontSize: !turn.speaker ? 'inherit' : '' },
                        onClick: function onClick() {
                          __instance.currentTime = turn.time;
                        }
                      },
                      _react2.default.createElement(_antd.Icon, { type: 'play-circle-o' }),
                      _react2.default.createElement(
                        'span',
                        null,
                        ' ',
                        new Date(turn.time * 1000).toUTCString().split(' ')[4].substr(3)
                      )
                    )
                  ),
                  _react2.default.createElement(
                    'div',
                    { className: 'listing__transcript__spans', style: { width: '100%' } },
                    turn.spans.map(function (span, i) {
                      return _react2.default.createElement(
                        'span',
                        {
                          key: i,
                          className: span.classes
                        },
                        span.words,
                        '\xA0'
                      );
                    })
                  )
                )
              );
            })
          )
        )
      );
    }
  }]);

  return Transcript;
}(_react2.default.Component);

Transcript.propTypes = {
  duration: _propTypes2.default.number.isRequired,
  currentTime: _propTypes2.default.number.isRequired,
  transcript: _propTypes2.default.array.isRequired,
  speakers: _propTypes2.default.arrayOf(_propTypes2.default.string).isRequired,
  activeTab: _propTypes2.default.number.isRequired,
  markersState: _propTypes2.default.object,
  paused: _propTypes2.default.bool.isRequired,
  identifiedRanges: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    startTime: _propTypes2.default.number,
    endTime: _propTypes2.default.number
  })).isRequired
};
exports.default = (0, _connectToPlayer2.default)()(Transcript);