'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.VolumeSlider = exports.constants = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.capitalize = capitalize;
exports.maxmin = maxmin;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactDom = require('react-dom');

var _reactDom2 = _interopRequireDefault(_reactDom);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; } // https://github.com/whoisandie/react-rangeslider
/*
* https://github.com/whoisandie/react-rangeslider/issues/3
* Not compatible with react 0.14 yet.
* Rewrite for new react version
* */


function capitalize(str) {
  return str.charAt(0).toUpperCase() + str.substr(1);
}

function maxmin(pos, min, max) {
  if (pos < min) {
    return min;
  }
  if (pos > max) {
    return max;
  }
  return pos;
}

var constants = exports.constants = {
  orientation: {
    horizontal: {
      dimension: 'width',
      direction: 'left',
      coordinate: 'x'
    },
    vertical: {
      dimension: 'height',
      direction: 'top',
      coordinate: 'y'
    }
  }
};

var VolumeSlider = exports.VolumeSlider = function (_React$Component) {
  _inherits(VolumeSlider, _React$Component);

  function VolumeSlider() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, VolumeSlider);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = VolumeSlider.__proto__ || Object.getPrototypeOf(VolumeSlider)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      limit: 0,
      grab: 0
    }, _this.handleSliderMouseDown = function (e) {
      var value = void 0,
          onChange = _this.props.onChange; // eslint-disable-line one-var
      if (!onChange) return;

      value = _this.position(e);
      onChange && onChange(value);
    }, _this.handleKnobMouseDown = function () {
      document.addEventListener('mousemove', _this.handleDrag);
      document.addEventListener('mouseup', _this.handleDragEnd);
    }, _this.handleDrag = function (nativeEvent) {
      nativeEvent.stopPropagation();
      nativeEvent.preventDefault();
      var value = void 0,
          onChange = _this.props.onChange; // eslint-disable-line one-var
      if (!onChange) return;

      value = _this.position(nativeEvent);
      onChange && onChange(value);
    }, _this.handleDragEnd = function () {
      document.removeEventListener('mousemove', _this.handleDrag);
      document.removeEventListener('mouseup', _this.handleDragEnd);
    }, _this.handleNoop = function (e) {
      e.nativeEvent.stopImmediatePropagation();
      e.stopPropagation();
      e.preventDefault();
    }, _this.getPositionFromValue = function (value) {
      var percentage = void 0,
          pos = void 0;
      var limit = _this.state.limit;
      var _this$props = _this.props,
          min = _this$props.min,
          max = _this$props.max;

      percentage = (value - min) / (max - min);
      pos = Math.round(percentage * limit);

      return pos;
    }, _this.getValueFromPosition = function (pos) {
      var percentage = void 0,
          value = void 0;
      var limit = _this.state.limit;
      var _this$props2 = _this.props,
          orientation = _this$props2.orientation,
          min = _this$props2.min,
          max = _this$props2.max,
          step = _this$props2.step;

      percentage = maxmin(pos, 0, limit) / (limit || 1);

      if (orientation === 'horizontal') {
        value = step * Math.round(percentage * (max - min) / step) + min;
      } else {
        value = max - (step * Math.round(percentage * (max - min) / step) + min);
      }

      return value;
    }, _this.position = function (e) {
      var pos = void 0,
          value = void 0,
          grab = _this.state.grab; // eslint-disable-line one-var
      var orientation = _this.props.orientation;

      var node = _reactDom2.default.findDOMNode(_this.refs.slider);
      var coordinateStyle = constants.orientation[orientation].coordinate;
      var directionStyle = constants.orientation[orientation].direction;
      var coordinate = e['client' + capitalize(coordinateStyle)];
      var direction = node.getBoundingClientRect()[directionStyle];

      pos = coordinate - direction - grab;
      value = _this.getValueFromPosition(pos);

      return value;
    }, _this.coordinates = function (pos) {
      var value = void 0,
          fillPos = void 0,
          handlePos = void 0;
      var _this$state = _this.state,
          limit = _this$state.limit,
          grab = _this$state.grab;
      var orientation = _this.props.orientation;


      value = _this.getValueFromPosition(pos);
      handlePos = _this.getPositionFromValue(value);

      if (orientation === 'horizontal') {
        fillPos = handlePos + grab;
      } else {
        fillPos = limit - handlePos + grab;
      }

      return {
        fill: fillPos,
        handle: handlePos
      };
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(VolumeSlider, [{
    key: 'componentDidMount',


    // Add window resize event listener here
    value: function componentDidMount() {
      var orientation = this.props.orientation;

      var dimension = capitalize(constants.orientation[orientation].dimension);
      var sliderPos = _reactDom2.default.findDOMNode(this.refs.slider)['offset' + dimension];
      var handlePos = _reactDom2.default.findDOMNode(this.refs.handle)['offset' + dimension];
      this.setState({
        limit: sliderPos - handlePos,
        grab: handlePos / 2
      });
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          value = _props.value,
          orientation = _props.orientation;


      var dimension = constants.orientation[orientation].dimension;
      var direction = constants.orientation[orientation].direction;

      var position = this.getPositionFromValue(value);
      var coords = this.coordinates(position);

      var fillStyle = _defineProperty({}, dimension, coords.fill + 'px');
      var handleStyle = _defineProperty({}, direction, coords.handle + 'px');
      var classes = 'rangeslider rangeslider-' + orientation;
      return _react2.default.createElement(
        'div',
        {
          ref: 'slider',
          className: classes,
          onMouseDown: this.handleSliderMouseDown,
          onClick: this.handleNoop },
        _react2.default.createElement('div', {
          ref: 'fill',
          className: 'rangeslider__fill',
          style: fillStyle }),
        _react2.default.createElement('div', {
          ref: 'handle',
          className: 'rangeslider__handle',
          onMouseDown: this.handleKnobMouseDown,
          onClick: this.handleNoop,
          style: handleStyle })
      );
    }
  }]);

  return VolumeSlider;
}(_react2.default.Component);

VolumeSlider.propTypes = {
  min: _propTypes2.default.number,
  max: _propTypes2.default.number,
  step: _propTypes2.default.number,
  value: _propTypes2.default.number,
  orientation: _propTypes2.default.string,
  onChange: _propTypes2.default.func
};
VolumeSlider.defaultProps = {
  min: 0,
  max: 100,
  step: 1,
  value: 0,
  orientation: 'horizontal'
};
exports.default = VolumeSlider;