'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _get = function get(object, property, receiver) { if (object === null) object = Function.prototype; var desc = Object.getOwnPropertyDescriptor(object, property); if (desc === undefined) { var parent = Object.getPrototypeOf(object); if (parent === null) { return undefined; } else { return get(parent, property, receiver); } } else if ("value" in desc) { return desc.value; } else { var getter = desc.get; if (getter === undefined) { return undefined; } return getter.call(receiver); } };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Base = require('./Base');

var _Base2 = _interopRequireDefault(_Base);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PLAYER_ID = 'react-jwplayer';

var JwPlayer = function (_VbsBase) {
  _inherits(JwPlayer, _VbsBase);

  function JwPlayer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, JwPlayer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = JwPlayer.__proto__ || Object.getPrototypeOf(JwPlayer)).call.apply(_ref, [this].concat(args))), _this), _this.playerId = PLAYER_ID + '_' + Date.now(), _this.isReady = false, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(JwPlayer, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      _get(JwPlayer.prototype.__proto__ || Object.getPrototypeOf(JwPlayer.prototype), 'componentDidMount', this).call(this);
    }
  }, {
    key: 'load',
    value: function load(url) {
      var _this2 = this;

      this.player = window.jwplayer(this.playerId).setup({
        file: url,
        primary: 'html5',
        width: this.props.width,
        height: this.props.height,
        controls: false,
        logo: {
          hide: true
        }
      });
      this.player.onReady(function () {
        _this2.isReady = true;
      });
      this.player.onComplete(function () {
        return _this2.props.onEnded();
      });
    }
  }, {
    key: 'play',
    value: function play() {
      if (this.player.getState() !== 'PLAYING') {
        this.player.play();
        this.onPlay();
      }
    }
  }, {
    key: 'pause',
    value: function pause() {
      var status = this.player.getState();
      if (status !== 'PAUSED' && status !== 'IDLE') {
        this.player.pause();
      }
    }
  }, {
    key: 'stop',
    value: function stop() {
      this.player.stop();
    }
  }, {
    key: 'seekTo',
    value: function seekTo(fraction) {
      _get(JwPlayer.prototype.__proto__ || Object.getPrototypeOf(JwPlayer.prototype), 'seekTo', this).call(this, fraction);
      this.player.seek(this.getDuration() * fraction);
    }
  }, {
    key: 'setVolume',
    value: function setVolume(fraction) {
      this.player.setVolume(fraction);
    }
  }, {
    key: 'getDuration',
    value: function getDuration() {
      return this.player.getDuration();
    }
  }, {
    key: 'getFractionPlayed',
    value: function getFractionPlayed() {
      if (!this.isReady) return null;
      var status = this.player.getState();
      if (status === 'BUFFERING') {
        return null;
      }
      return this.player.getPosition() / this.getDuration();
    }
  }, {
    key: 'getFractionLoaded',
    value: function getFractionLoaded() {
      if (!this.isReady || !this.player.getBuffer) return null;
      return this.player.getBuffer();
    }
  }, {
    key: 'render',
    value: function render() {
      return _react2.default.createElement('div', { id: this.playerId });
    }
  }], [{
    key: 'canPlay',
    value: function canPlay(url) {
      return true;
    }
  }]);

  return JwPlayer;
}(_Base2.default);

JwPlayer.displayName = 'JwPlayer';
exports.default = JwPlayer;