'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _ReactPlayer2 = require('react-player/lib/ReactPlayer');

var _ReactPlayer3 = _interopRequireDefault(_ReactPlayer2);

var _playersList = require('./playersList');

var _playersList2 = _interopRequireDefault(_playersList);

var _props = require('./props');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var PROGRESS_FREQUENCY = 1000;

var VbsReactPlayer = function (_ReactPlayer) {
  _inherits(VbsReactPlayer, _ReactPlayer);

  function VbsReactPlayer() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, VbsReactPlayer);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = VbsReactPlayer.__proto__ || Object.getPrototypeOf(VbsReactPlayer)).call.apply(_ref, [this].concat(args))), _this), _this.progress = function () {
      if (_this.props.url && _this.player) {
        var loaded = _this.player.getFractionLoaded() || 0;
        var played = _this.player.getFractionPlayed() || 0;
        var duration = _this.player.getDuration(); // added
        var progress = {};
        if (loaded !== _this.prevLoaded) {
          progress.loaded = loaded;
        }
        if (played !== _this.prevPlayed && _this.props.playing) {
          progress.played = played;
        }
        if (progress.loaded || progress.played) {
          _this.props.onProgress(progress);
        }
        // On occasion, players will return infinity for different reasons (due to HTTP request
        // styles for example, where the actual length isn't yet known). For the moment, don't
        // emit an event in this case. In future we can likely handle this in a smarter way.
        if (duration && duration !== Infinity && duration > 0) {
          _this.props.onDuration(duration);
        }
        _this.prevLoaded = loaded;
        _this.prevPlayed = played;
      }
      _this.progressTimeout = setTimeout(_this.progress, PROGRESS_FREQUENCY);
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(VbsReactPlayer, [{
    key: 'render',
    value: function render() {
      var _this2 = this;

      var style = {
        width: this.props.width,
        height: this.props.height
      };
      return _react2.default.createElement(
        'div',
        { style: style, className: this.props.className },
        _playersList2.default.map(function (player) {
          return _this2.props.activePlayer === player.displayName && _this2.renderPlayer(player);
        })
      );
    }
  }], [{
    key: 'canPlay',
    value: function canPlay(url) {
      return _playersList2.default.some(function (player) {
        return player.canPlay(url);
      });
    }
  }]);

  return VbsReactPlayer;
}(_ReactPlayer3.default);

VbsReactPlayer.propTypes = _props.propTypes;
VbsReactPlayer.defaultProps = _props.defaultProps;
exports.default = VbsReactPlayer;