'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _redux = require('redux');

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _antd = require('antd');

var _markers = require('../../../redux/modules/markers');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// TODO: This should be using the __player interface instead of old redux actions.
var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    setMarkers: (0, _redux.bindActionCreators)(_markers.setMarkers, dispatch)
  };
};

var Bookmarks = function Bookmarks(_ref) {
  var folders = _ref.folders,
      setMarkers = _ref.setMarkers;
  return _react2.default.createElement(
    _antd.Menu,
    {
      mode: 'inline',
      theme: 'dark',
      onClick: setMarkers
    },
    folders.map(function (folder) {
      return _react2.default.createElement(
        _antd.Menu.SubMenu,
        { key: folder.name, title: folder.name },
        folder.bookmarks.map(function (bookmark) {
          return _react2.default.createElement(
            _antd.Menu.Item,
            { title: bookmark.name, key: folder.name + '-' + bookmark.name },
            bookmark.name
          );
        })
      );
    })
  );
};

Bookmarks.propTypes = {
  folders: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    name: _propTypes2.default.name,
    bookmarks: _propTypes2.default.arrayOf(_propTypes2.default.shape({
      name: _propTypes2.default.name
    }))
  })).isRequired
};

exports.default = (0, _reactRedux.connect)(undefined, mapDispatchToProps)(Bookmarks);