'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _antd = require('antd');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state) {
  return {
    classifiers: state.mediaData.get('classifiers').toJS()
  };
};

var TabClassifiers = function (_React$PureComponent) {
  _inherits(TabClassifiers, _React$PureComponent);

  function TabClassifiers() {
    _classCallCheck(this, TabClassifiers);

    return _possibleConstructorReturn(this, (TabClassifiers.__proto__ || Object.getPrototypeOf(TabClassifiers)).apply(this, arguments));
  }

  _createClass(TabClassifiers, [{
    key: 'render',
    value: function render() {
      var classifiers = this.props.classifiers;

      var titleStyle = { fontSize: '18px', fontWeight: 800, paddingBottom: '10px' };
      return _react2.default.createElement(
        _antd.Row,
        { type: 'flex', gutter: 16 },
        !classifiers.length && 'No results found.',
        classifiers.map(function (classifier) {
          var icon = void 0;
          if (classifier.type === 'binary') {
            if (classifier.class === 0) {
              icon = '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" x="0px" y="0px" viewBox="0 0 438.533 438.533" style="enable-background:new 0 0 438.533 438.533;" xml:space="preserve"><g><path d="M409.133,109.203c-19.608-33.592-46.205-60.189-79.798-79.796C295.736,9.801,259.058,0,219.273,0   c-39.781,0-76.47,9.801-110.063,29.407c-33.595,19.604-60.192,46.201-79.8,79.796C9.801,142.8,0,179.489,0,219.267   c0,39.78,9.804,76.463,29.407,110.062c19.607,33.592,46.204,60.189,79.799,79.798c33.597,19.605,70.283,29.407,110.063,29.407   s76.47-9.802,110.065-29.407c33.593-19.602,60.189-46.206,79.795-79.798c19.603-33.596,29.403-70.284,29.403-110.062   C438.533,179.485,428.732,142.795,409.133,109.203z M322.621,270.939c3.617,3.613,5.428,7.905,5.428,12.854   c0,5.133-1.811,9.514-5.428,13.127l-25.693,25.701c-3.614,3.613-7.994,5.42-13.135,5.42c-4.948,0-9.236-1.807-12.847-5.42   l-51.676-51.682l-51.678,51.682c-3.616,3.613-7.898,5.42-12.847,5.42c-5.14,0-9.517-1.807-13.134-5.42l-25.697-25.701   c-3.616-3.613-5.424-7.994-5.424-13.127c0-4.948,1.809-9.24,5.424-12.854l51.678-51.673l-51.678-51.678   c-3.616-3.612-5.424-7.898-5.424-12.847c0-5.14,1.809-9.517,5.424-13.134l25.697-25.693c3.617-3.616,7.994-5.424,13.134-5.424   c4.949,0,9.231,1.809,12.847,5.424l51.678,51.674l51.676-51.674c3.61-3.616,7.898-5.424,12.847-5.424   c5.141,0,9.521,1.809,13.135,5.424l25.693,25.693c3.617,3.617,5.428,7.994,5.428,13.134c0,4.948-1.811,9.235-5.428,12.847   l-51.675,51.678L322.621,270.939z" fill="#D80027"/></g></svg>';
            } else {
              icon = '<svg xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink" version="1.1" viewBox="0 0 44 44" enable-background="new 0 0 44 44"><path d="m22,0c-12.2,0-22,9.8-22,22s9.8,22 22,22 22-9.8 22-22-9.8-22-22-22zm12.7,15.1l0,0-16,16.6c-0.2,0.2-0.4,0.3-0.7,0.3-0.3,0-0.6-0.1-0.7-0.3l-7.8-8.4-.2-.2c-0.2-0.2-0.3-0.5-0.3-0.7s0.1-0.5 0.3-0.7l1.4-1.4c0.4-0.4 1-0.4 1.4,0l.1,.1 5.5,5.9c0.2,0.2 0.5,0.2 0.7,0l13.4-13.9h0.1c0.4-0.4 1-0.4 1.4,0l1.4,1.4c0.4,0.3 0.4,0.9 0,1.3z" fill="#91DC5A"/></svg>';
            }
            icon = 'data:image/svg+xml;utf8,' + icon;
          } else if (classifier.type === 'multiclass') {
            // Nothing to prep as yet. Keeping this else as a placeholder.
          }
          return _react2.default.createElement(
            _antd.Col,
            { key: classifier.id, span: 8 },
            icon ? _react2.default.createElement(
              _antd.Card,
              { bordered: false, title: classifier.name },
              _react2.default.createElement(_antd.Icon, { type: 'close-circle', alt: classifier.label, title: classifier.label })
            ) : _react2.default.createElement(
              _antd.Card,
              { bordered: false, title: classifier.name },
              _react2.default.createElement(
                'div',
                { style: { fontSize: '18px' } },
                classifier.label
              )
            )
          );
        })
      );
    }
  }]);

  return TabClassifiers;
}(_react2.default.PureComponent);

TabClassifiers.propTypes = {
  classifiers: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    id: _propTypes2.default.string.isRequired,
    name: _propTypes2.default.string.isRequired,
    type: _propTypes2.default.oneOf(['binary', 'multiclass']),
    label: _propTypes2.default.string.isRequired,
    class: _propTypes2.default.number.isRequired
  })).isRequired
};
exports.default = (0, _reactRedux.connect)(mapStateToProps)(TabClassifiers);