'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _reactRedux = require('react-redux');

var _antd = require('antd');

var _Timeline = require('./Timeline/Timeline');

var _Timeline2 = _interopRequireDefault(_Timeline);

var _Transcript = require('../Transcript');

var _Transcript2 = _interopRequireDefault(_Transcript);

var _PrimaryControls = require('./Controls/PrimaryControls');

var _PrimaryControls2 = _interopRequireDefault(_PrimaryControls);

var _TabKeywords = require('../TabKeywords');

var _TabKeywords2 = _interopRequireDefault(_TabKeywords);

var _SearchBar = require('../SearchBar');

var _SearchBar2 = _interopRequireDefault(_SearchBar);

var _TabClassifiers = require('../TabClassifiers');

var _TabClassifiers2 = _interopRequireDefault(_TabClassifiers);

var _Volume = require('./Volume');

var _Volume2 = _interopRequireDefault(_Volume);

var _Download = require('./Download');

var _Download2 = _interopRequireDefault(_Download);

var _BoxTrack = require('./Timeline/BoxTrack');

var _BoxTrack2 = _interopRequireDefault(_BoxTrack);

var _PointTrack = require('./Timeline/PointTrack');

var _PointTrack2 = _interopRequireDefault(_PointTrack);

var _StepAxis = require('./Timeline/StepAxis');

var _StepAxis2 = _interopRequireDefault(_StepAxis);

var _BarAxis = require('./Timeline/BarAxis');

var _BarAxis2 = _interopRequireDefault(_BarAxis);

var _PositionMarker = require('./Timeline/PositionMarker');

var _PositionMarker2 = _interopRequireDefault(_PositionMarker);

var _MediaBridge = require('./MediaBridge');

var _MediaBridge2 = _interopRequireDefault(_MediaBridge);

var _Common = require('../../../common/Common');

var _Bookmarks = require('./Bookmarks');

var _Bookmarks2 = _interopRequireDefault(_Bookmarks);

var _Classifiers = require('./Classifiers');

var _Classifiers2 = _interopRequireDefault(_Classifiers);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var rightPlayerButtonsStyle = {
  background: 'none',
  border: 'none',
  padding: '0',
  display: 'block',
  margin: '0 auto'
};

var DETECTOR_COLORS = ['#AEDBFC', '#D5BBF4', '#CBECA9', '#F5BDD8', '#F4B4AF', '#FBE59B', '#F5BE9C'];

var mapStateToProps = function mapStateToProps(state) {
  return {
    identifiedRanges: state.search.identifiedRanges
  };
};

var PlayerUI = function (_React$Component) {
  _inherits(PlayerUI, _React$Component);

  function PlayerUI() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, PlayerUI);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = PlayerUI.__proto__ || Object.getPrototypeOf(PlayerUI)).call.apply(_ref, [this].concat(args))), _this), _this.state = {
      view: '0',
      bookmarksView: ''
    }, _this.changeView = function (item) {
      _this.setState({ view: item.key });
    }, _this.changeBookmarksView = function (item) {
      var bookmarksView = _this.state.bookmarksView;

      _this.setState({ bookmarksView: item.key === bookmarksView ? '' : item.key });
    }, _this.swichView = function (view) {
      var _this$props = _this.props,
          playerState = _this$props.playerState,
          mediaData = _this$props.mediaData,
          identifiedRanges = _this$props.identifiedRanges;


      switch (view) {
        case '0':
          return !!mediaData.transcript.length && _react2.default.createElement(_Transcript2.default, {
            duration: playerState.duration,
            played: playerState.played,
            transcript: mediaData.transcript,
            utterances: mediaData.utterances,
            speakers: mediaData.speakers,
            activeTab: mediaData.view.activeTab,
            identifiedRanges: identifiedRanges
          });
        case '1':
          return !!mediaData.topics.length && _react2.default.createElement(_TabKeywords2.default, {
            type: 'keywords',
            activeTopic: mediaData.activeTopic,
            topics: mediaData.topics
          });
        case '2':
          return !!mediaData.groups.length && _react2.default.createElement(_TabKeywords2.default, {
            type: 'groups',
            activeTopic: mediaData.activeGroup,
            topics: mediaData.groups
          });
        case '3':
          return mediaData.classifiers && _react2.default.createElement(_TabClassifiers2.default, null);
        default:
          return undefined;
      }
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }
  // Not bothering to map these proptypes since its old stuff.


  _createClass(PlayerUI, [{
    key: 'renderDefaultLayout',
    value: function renderDefaultLayout(_ref2) {
      var channels = _ref2.channels,
          bookmarks = _ref2.bookmarks,
          view = _ref2.view,
          identifiedRanges = _ref2.identifiedRanges,
          playerState = _ref2.playerState,
          mediaData = _ref2.mediaData,
          markersState = _ref2.markersState;
      var bookmarksView = this.state.bookmarksView;

      // background: '#001525'

      return _react2.default.createElement(
        _antd.Layout,
        { className: 'vb-player' },
        _react2.default.createElement(
          _antd.Layout.Content,
          null,
          _react2.default.createElement(
            _antd.Layout,
            null,
            _react2.default.createElement(
              _antd.Menu,
              { onSelect: this.changeView, theme: 'dark', defaultSelectedKeys: [view], mode: 'horizontal' },
              _react2.default.createElement(
                _antd.Menu.Item,
                { key: '0' },
                _react2.default.createElement(_antd.Icon, { type: 'file-text' }),
                _react2.default.createElement(
                  'span',
                  null,
                  'Transcript'
                )
              ),
              _react2.default.createElement(
                _antd.Menu.Item,
                { key: '3' },
                _react2.default.createElement(_antd.Icon, { type: 'line-chart' }),
                _react2.default.createElement(
                  'span',
                  null,
                  'Classifiers'
                )
              )
            )
          ),
          _react2.default.createElement(
            _antd.Layout,
            { style: { background: '#001525' } },
            _react2.default.createElement(_MediaBridge2.default, { type: playerState.type, src: playerState.url })
          ),
          _react2.default.createElement(
            _antd.Layout,
            null,
            _react2.default.createElement(
              _antd.Layout.Sider,
              { style: { background: '#fff' }, width: 128 },
              _react2.default.createElement(
                _antd.Row,
                { style: { height: '100%' }, type: 'flex', justify: 'center', align: 'middle' },
                _react2.default.createElement(_PrimaryControls2.default, { bookmarks: bookmarks })
              )
            ),
            _react2.default.createElement(
              _antd.Layout.Content,
              { style: { background: '#fff', padding: '10px 10px 10px 0px' } },
              _react2.default.createElement(
                _Timeline2.default,
                null,
                !!bookmarks.length && _react2.default.createElement(_PointTrack2.default, { points: bookmarks }),
                _react2.default.createElement(
                  _PositionMarker2.default,
                  null,
                  _react2.default.createElement(_StepAxis2.default, null),
                  _react2.default.createElement(_BarAxis2.default, { channels: channels }),
                  mediaData.detectors.map(function (d, i) {
                    return _react2.default.createElement(_BoxTrack2.default, {
                      key: d.detector + d.class,
                      intervals: d.intervals,
                      title: d.title,
                      color: DETECTOR_COLORS[i % DETECTOR_COLORS.length]
                    });
                  })
                )
              )
            ),
            _react2.default.createElement(
              _antd.Layout.Sider,
              { width: 32 },
              _react2.default.createElement(
                _antd.Row,
                {
                  type: 'flex',
                  justify: 'space-around',
                  style: {
                    height: '100%',
                    background: '#fff',
                    flexDirection: 'column',
                    flexWrap: 'nowrap'
                  }
                },
                _react2.default.createElement(
                  _antd.Popover,
                  {
                    placement: 'bottom',
                    title: '',
                    content: _react2.default.createElement(_Volume2.default, null),
                    trigger: 'click'
                  },
                  _react2.default.createElement(
                    'div',
                    null,
                    _react2.default.createElement(
                      _antd.Button,
                      { style: rightPlayerButtonsStyle },
                      _react2.default.createElement(_antd.Icon, { type: 'sound' })
                    )
                  )
                ),
                _react2.default.createElement(
                  _Download2.default,
                  null,
                  _react2.default.createElement(
                    _antd.Button,
                    { style: rightPlayerButtonsStyle },
                    _react2.default.createElement(_antd.Icon, { type: 'cloud-download' })
                  )
                )
              )
            )
          ),
          _react2.default.createElement(
            _antd.Layout.Content,
            { style: { borderTop: '1px #cacaca solid' } },
            this.swichView(view)
          ),
          _react2.default.createElement(
            _antd.Layout.Footer,
            { style: { padding: '0', position: 'relative', zIndex: '99' } },
            _react2.default.createElement(
              _antd.Layout.Content,
              {
                style: {
                  position: 'absolute',
                  transform: 'translateY(-100%)',
                  width: '100%',
                  borderTop: '1px #cacaca solid'
                }
              },
              this.swichView(bookmarksView)
            ),
            _react2.default.createElement(
              _antd.Row,
              {
                type: 'flex',
                justify: 'space-between',
                align: 'middle',
                style: {
                  background: '#fff',
                  flexWrap: 'nowrap'
                }
              },
              _react2.default.createElement(
                _antd.Menu,
                { onClick: this.changeBookmarksView, theme: 'light', selectedKeys: [bookmarksView], mode: 'horizontal' },
                _react2.default.createElement(
                  _antd.Menu.Item,
                  { key: '1', disabled: !mediaData.topics.length },
                  _react2.default.createElement(
                    'span',
                    null,
                    'Knowledge '
                  ),
                  _react2.default.createElement(_antd.Badge, {
                    style: { backgroundColor: '#fff', color: '#999', boxShadow: '0 0 0 1px #d9d9d9 inset' },
                    count: mediaData.topics.length
                  })
                ),
                _react2.default.createElement(
                  _antd.Menu.Item,
                  { key: '2', disabled: !mediaData.groups.length },
                  _react2.default.createElement(
                    'span',
                    null,
                    'Spotting Groups '
                  ),
                  _react2.default.createElement(_antd.Badge, {
                    style: { backgroundColor: '#fff', color: '#999', boxShadow: '0 0 0 1px #d9d9d9 inset' },
                    count: mediaData.groups.length
                  })
                )
              ),
              _react2.default.createElement(
                'div',
                { style: { padding: '0 20px' } },
                _react2.default.createElement(_SearchBar2.default, { words: mediaData.transcript })
              )
            )
          )
        )
      );
    }
  }, {
    key: 'renderDemoLayout',
    value: function renderDemoLayout(_ref3) {
      var channels = _ref3.channels,
          bookmarks = _ref3.bookmarks,
          view = _ref3.view,
          identifiedRanges = _ref3.identifiedRanges,
          playerState = _ref3.playerState,
          mediaData = _ref3.mediaData,
          markersState = _ref3.markersState;

      return _react2.default.createElement(
        _antd.Layout,
        { className: 'vb-player' },
        _react2.default.createElement(
          _antd.Layout.Content,
          null,
          _react2.default.createElement(
            _antd.Layout,
            { style: { background: '#001525' } },
            _react2.default.createElement(_MediaBridge2.default, { type: playerState.type, src: playerState.url })
          ),
          _react2.default.createElement(
            _antd.Layout,
            null,
            _react2.default.createElement(
              _antd.Layout.Sider,
              { style: { background: '#fff' }, width: 128 },
              _react2.default.createElement(
                _antd.Row,
                { style: { height: '100%' }, type: 'flex', justify: 'center', align: 'middle' },
                _react2.default.createElement(_PrimaryControls2.default, { bookmarks: bookmarks })
              )
            ),
            _react2.default.createElement(
              _antd.Layout.Content,
              { style: { background: '#fff', padding: '10px 10px 10px 0px' } },
              _react2.default.createElement(
                _Timeline2.default,
                null,
                !!bookmarks.length && _react2.default.createElement(_PointTrack2.default, { points: bookmarks }),
                _react2.default.createElement(
                  _PositionMarker2.default,
                  null,
                  _react2.default.createElement(_StepAxis2.default, null),
                  _react2.default.createElement(_BarAxis2.default, { channels: channels }),
                  mediaData.detectors.map(function (d, i) {
                    return _react2.default.createElement(_BoxTrack2.default, {
                      key: d.detector + d.class,
                      intervals: d.intervals,
                      title: d.title,
                      color: DETECTOR_COLORS[i % DETECTOR_COLORS.length]
                    });
                  })
                )
              )
            ),
            _react2.default.createElement(
              _antd.Layout.Sider,
              { width: 32 },
              _react2.default.createElement(
                _antd.Row,
                {
                  type: 'flex',
                  justify: 'space-around',
                  style: {
                    height: '100%',
                    background: '#fff',
                    flexDirection: 'column',
                    flexWrap: 'nowrap'
                  }
                },
                _react2.default.createElement(
                  _Download2.default,
                  null,
                  _react2.default.createElement(
                    _antd.Button,
                    { style: rightPlayerButtonsStyle },
                    _react2.default.createElement(_antd.Icon, { type: 'cloud-download' })
                  )
                )
              )
            )
          ),
          _react2.default.createElement(
            _antd.Layout,
            { style: { background: '#fff' } },
            _react2.default.createElement(
              _antd.Tabs,
              { type: 'card', tabBarStyle: { padding: '0 8px', marginBottom: '0' }, tabBarExtraContent: _react2.default.createElement(_SearchBar2.default, { words: mediaData.transcript }) },
              _react2.default.createElement(
                _antd.Tabs.TabPane,
                { tab: 'Spotting Groups', key: '1' },
                !!mediaData.groups.length && _react2.default.createElement(_TabKeywords2.default, {
                  type: 'groups',
                  activeTopic: mediaData.activeGroup,
                  topics: mediaData.groups
                })
              ),
              _react2.default.createElement(
                _antd.Tabs.TabPane,
                { tab: 'Classifiers', key: '2' },
                mediaData.classifiers && _react2.default.createElement(_TabClassifiers2.default, null)
              )
            )
          ),
          _react2.default.createElement(
            _antd.Layout,
            null,
            _react2.default.createElement(
              _antd.Layout.Content,
              { style: { borderTop: '1px #cacaca solid' } },
              this.swichView(view)
            )
          )
        )
      );
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          viewTemplate = _props.viewTemplate,
          identifiedRanges = _props.identifiedRanges,
          playerState = _props.playerState,
          mediaData = _props.mediaData,
          markersState = _props.markersState;
      var view = this.state.view;


      var bookmarks = [].concat(Object.values(markersState.markers).map(function (marker) {
        return { time: marker.time, color: '#5BB28E' };
      }), identifiedRanges.map(function (_ref4) {
        var startTime = _ref4.startTime;
        return { time: startTime / 1000, color: '#7AB99B' };
      }));

      var channels = mediaData.transcriptSpeakers.map(function (_ref5) {
        var start = _ref5.start,
            name = _ref5.name;
        return { start: start / 1000, color: (0, _Common.getSpeakerColor)(name) };
      });

      return viewTemplate === 'demo' ? this.renderDemoLayout({ channels: channels, bookmarks: bookmarks, identifiedRanges: identifiedRanges, playerState: playerState, mediaData: mediaData, markersState: markersState, view: view }) : this.renderDefaultLayout({ channels: channels, bookmarks: bookmarks, identifiedRanges: identifiedRanges, playerState: playerState, mediaData: mediaData, markersState: markersState, view: view });
    }
  }]);

  return PlayerUI;
}(_react2.default.Component);

PlayerUI.propTypes = {
  mediaData: _propTypes2.default.object.isRequired,
  playerState: _propTypes2.default.object.isRequired,
  identifiedRanges: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    startTime: _propTypes2.default.number,
    endTime: _propTypes2.default.number
  })).isRequired,
  markersState: _propTypes2.default.object,
  viewTemplate: _propTypes2.default.string
};
PlayerUI.defaultProps = {
  markersState: {}
};
exports.default = (0, _reactRedux.connect)(mapStateToProps)(PlayerUI);

/*
          <Row
            type="flex"
            justify="space-between"
            align="middle"
            style={{
              background: '#fff',
              flexWrap: 'nowrap',
            }}
          >
            <Tabs tabBarExtraContent={<SearchBar words={mediaData.transcript}/>}>
              <Tabs.TabPane tab="Spotting Groups" key="1">
                {!!mediaData.groups.length &&
                  <TabKeywords
                    type="groups"
                    activeTopic={mediaData.activeGroup}
                    topics={mediaData.groups}
                  />
                };
              </Tabs.TabPane>
            </Tabs>

              <Menu onClick={this.changeBookmarksView} theme="light" selectedKeys={[bookmarksView]} mode="horizontal">
                {!demo &&
                <Menu.Item key="1" disabled={!mediaData.topics.length}>
                  <span>Knowledge </span>
                  <Badge
                    style={{ backgroundColor: '#fff', color: '#999', boxShadow: '0 0 0 1px #d9d9d9 inset' }}
                    count={mediaData.topics.length}
                  />
                </Menu.Item>
                }
                <Menu.Item key="2" disabled={!mediaData.groups.length}>
                  <span>Spotting Groups </span>
                  <Badge
                    style={{ backgroundColor: '#fff', color: '#999', boxShadow: '0 0 0 1px #d9d9d9 inset' }}
                    count={mediaData.groups.length}
                  />
                </Menu.Item>
              </Menu>
              <div style={{ padding: '0 20px' }}>
                <SearchBar words={mediaData.transcript}/>
              </div>
</Row>
<Layout.Content>
  {this.swichView(bookmarksView)}
</Layout.Content>

  renderDemoLayout() {
    const { identifiedRanges, playerState, mediaData, markersState, setActiveTopic } = this.props;
    const { view, bookmarksView } = this.state;

    const bookmarks = [].concat(
      Object.values(markersState.markers).map(marker => ({ time: marker.time, color: '#5BB28E' })),
      identifiedRanges.map(({ startTime }) => ({ time: startTime / 1000, color: '#7AB99B' })),
    );

    // TODO: There shouldn't be two types of bookmarks
    const folders = mediaData.topics.map(topic => ({
      name: topic.name,
      bookmarks: topic.keywords ? topic.keywords.map(keyword => ({ name: keyword.name })) : [],
    }));

    const channels = mediaData.transcriptSpeakers.map(
      ({ start, name }) => ({ start, color: getSpeakerColor(name) }),
    );
    // background: '#001525'
    return (
      <Layout className="vb-player">
        <Layout.Sider>
          <Bookmarks folders={folders} />
        </Layout.Sider>
        <Layout.Content>
          <Layout style={{ background: '#001525' }}>
            <MediaBridge type={playerState.type} src={playerState.url} />
          </Layout>
          <Layout>
            <Layout.Sider style={{background: '#fff'}} width={128}>
              <Row style={{height: '100%'}} type="flex" justify="center" align="middle">
                <PrimaryControls bookmarks={bookmarks} />
              </Row>
            </Layout.Sider>
            <Layout.Content style={{ background: '#fff', padding: '10px 10px 10px 0px' }}>
              <Timeline>
                {!!bookmarks.length && <PointTrack points={bookmarks} />}
                <PositionMarker>
                  <StepAxis />
                  <BarAxis channels={channels} />
                  {mediaData.detectors.map((d, i) => (
                    <BoxTrack
                      key={d.detector + d.class}
                      intervals={d.intervals}
                      title={d.title}
                      color={DETECTOR_COLORS[i % DETECTOR_COLORS.length]}
                    />
                  ))}
                </PositionMarker>
              </Timeline>
            </Layout.Content>
            <Layout.Sider width={32}>
              <Row
                type="flex"
                justify="space-around"
                style={{
                  height: '100%',
                  background: '#fff',
                  flexDirection: 'column',
                  flexWrap: 'nowrap',
                }}
              >
                <Popover
                  placement="bottom"
                  title=""
                  content={<Volume />}
                  trigger="click"
                >
                  <div>
                    <Button style={rightPlayerButtonsStyle}>
                      <Icon type="sound" />
                    </Button>
                  </div>
                </Popover>
              </Row>
            </Layout.Sider>
          </Layout>
          <Layout>
            <Layout>
              <Layout.Content style={{ borderTop: '1px #cacaca solid', maxHeight: '400px' }}>
                {this.swichView(view)}
              </Layout.Content>
              { mediaData.classifiers && <TabClassifiers /> }
            </Layout>
          </Layout>
        </Layout.Content>
      </Layout>
    );

<Layout>
            <Menu onSelect={this.changeView} theme="dark" defaultSelectedKeys={[view]} mode="horizontal">
              <Menu.Item key="0">
                <Icon type="file-text" />
                <span>Transcript</span>
              </Menu.Item>
              <Menu.Item key="3">
                <Icon type="line-chart" />
                <span>Classifiers</span>
              </Menu.Item>
            </Menu>
          </Layout>
<Row
                type="flex"
                justify="space-between"
                align="middle"
                style={{
                  background: '#fff',
                  flexWrap: 'nowrap',
                }}
              >
                <Menu onClick={this.changeBookmarksView} theme="light" selectedKeys={[bookmarksView]} mode="horizontal">
                  <Menu.Item key="2" disabled={!mediaData.groups.length}>
                    <span>Spotting Groups </span>
                    <Badge
                      style={{ backgroundColor: '#fff', color: '#999', boxShadow: '0 0 0 1px #d9d9d9 inset' }}
                      count={mediaData.groups.length}
                    />
                  </Menu.Item>
                </Menu>
                <div style={{ padding: '0 20px' }}>
                  <SearchBar words={mediaData.transcript} />
                </div>
              </Row>
 */