'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _connectToPlayer = require('../connectToPlayer');

var _connectToPlayer2 = _interopRequireDefault(_connectToPlayer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BarAxis = function BarAxis(_ref) {
  var duration = _ref.duration,
      channels = _ref.channels;
  return duration && (channels.length ? _react2.default.createElement(
    'svg',
    { width: '100%', height: '10px' },
    _react2.default.createElement('rect', {
      fill: '#e0e0e0',
      width: '100%',
      height: '100%'
    }),
    channels.map(function (_ref2) {
      var start = _ref2.start,
          _ref2$color = _ref2.color,
          color = _ref2$color === undefined ? 'black' : _ref2$color;
      return _react2.default.createElement('rect', {
        key: start,
        x: start * 100 / duration + '%',
        fill: color,
        width: '100%',
        height: '100%'
      });
    })
  ) : _react2.default.createElement(
    'svg',
    { width: '100%', height: '10px' },
    _react2.default.createElement('rect', {
      fill: '#4190F7',
      width: '100%',
      height: '100%'
    })
  ));
};

BarAxis.propTypes = {
  duration: _propTypes2.default.number.isRequired,
  channels: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    start: _propTypes2.default.number.isRequired,
    color: _propTypes2.default.string
  })).isRequired
};

BarAxis.defaultProps = {};

exports.default = (0, _connectToPlayer2.default)()(BarAxis);