'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _antd = require('antd');

var _connectToPlayer = require('../connectToPlayer');

var _connectToPlayer2 = _interopRequireDefault(_connectToPlayer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var BoxTrack = function BoxTrack(_ref) {
  var title = _ref.title,
      intervals = _ref.intervals,
      duration = _ref.duration,
      color = _ref.color;
  return duration && _react2.default.createElement(
    _antd.Tooltip,
    { placement: 'left', title: title },
    _react2.default.createElement(
      'svg',
      { width: '100%', height: '10px', shapeRendering: 'crispEdges' },
      intervals.map(function (_ref2) {
        var start = _ref2.start,
            end = _ref2.end;
        return _react2.default.createElement('rect', {
          key: start + end,
          x: start * 100 / duration + '%',
          width: (end - start) * 100 / duration + '%',
          height: '100%',
          fill: color,
          y: '0'
        });
      })
    )
  );
};

BoxTrack.propTypes = {
  title: _propTypes2.default.string.isRequired,
  intervals: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    start: _propTypes2.default.number.isRequired,
    end: _propTypes2.default.number.isRequired
  })).isRequired,
  duration: _propTypes2.default.number.isRequired,
  color: _propTypes2.default.string
};

BoxTrack.defaultProps = {
  color: 'black'
};

exports.default = (0, _connectToPlayer2.default)()(BoxTrack);