'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.IntervalOccurrence = exports.PointOccurrence = undefined;

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PointOccurrence = exports.PointOccurrence = function PointOccurrence(_ref) {
  var time = _ref.time,
      color = _ref.color;
  return _react2.default.createElement(
    'g',
    { transform: 'translate(' + (time - 8) + ', 0)' },
    _react2.default.createElement('line', { x1: '8', y1: '0', x2: '8', y2: '100%', stroke: color, opacity: '0.3', strokeWidth: '1px' }),
    _react2.default.createElement('polygon', { points: '8,12 0,0 16,0', fill: color })
  );
};

PointOccurrence.defaultProps = {
  color: '#89DB50'
};

var IntervalOccurrence = exports.IntervalOccurrence = function IntervalOccurrence(_ref2) {
  var start = _ref2.start,
      end = _ref2.end,
      color = _ref2.color;
  return _react2.default.createElement(
    'g',
    { transform: 'translate(' + start + ', 0)' },
    _react2.default.createElement('rect', { height: '100%', width: end - start, x: '0', y: '0', fill: color })
  );
};

IntervalOccurrence.defaultProps = {
  color: '#006EB8'
};