'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _antd = require('antd');

var _connectToPlayer = require('../connectToPlayer');

var _connectToPlayer2 = _interopRequireDefault(_connectToPlayer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PointTrack = function PointTrack(_ref) {
  var points = _ref.points,
      duration = _ref.duration,
      __instance = _ref.__instance;
  return duration && _react2.default.createElement(
    'svg',
    { width: '100%', height: '12px' },
    points.map(function (_ref2) {
      var time = _ref2.time,
          title = _ref2.title,
          color = _ref2.color;
      return _react2.default.createElement(
        _antd.Tooltip,
        {
          key: time,
          placement: 'left',
          title: title
        },
        _react2.default.createElement(
          'g',
          { transform: 'translate(-8, 0)' },
          _react2.default.createElement(
            'svg',
            {
              width: '16',
              height: '12',
              x: time * 100 / duration + '%',
              y: '0',
              style: { cursor: 'pointer' },
              viewBox: '0 0 100 100',
              preserveAspectRatio: 'none',
              onClick: function onClick(e) {
                e.stopPropagation();
                __instance.currentTime = time; // TODO: this should be a function not assignment
              }
            },
            _react2.default.createElement('polygon', { points: '0,0 100,0 50,100', fill: color })
          )
        )
      );
    })
  );
};

PointTrack.propTypes = {
  points: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    time: _propTypes2.default.number.isRequired,
    title: _propTypes2.default.string,
    color: _propTypes2.default.string
  })).isRequired,
  duration: _propTypes2.default.number.isRequired,
  __instance: _propTypes2.default.instanceOf(Element).isRequired
};

PointTrack.defaultProps = {};

exports.default = (0, _connectToPlayer2.default)()(PointTrack);