'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _connectToPlayer = require('../connectToPlayer');

var _connectToPlayer2 = _interopRequireDefault(_connectToPlayer);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var PositionMarker = function PositionMarker(_ref) {
  var currentTime = _ref.currentTime,
      duration = _ref.duration,
      children = _ref.children;
  return duration && _react2.default.createElement(
    'div',
    { style: { width: '100%', position: 'relative' } },
    _react2.default.createElement(
      'svg',
      { width: '100%', height: '100%', style: { position: 'absolute', pointerEvents: 'none' } },
      _react2.default.createElement('line', {
        vectorEffect: 'non-scaling-stroke',
        strokeWidth: '1px',
        stroke: 'black',
        y1: '0',
        y2: '100%',
        x1: currentTime * 100 / duration + '%',
        x2: currentTime * 100 / duration + '%'
      }),
      _react2.default.createElement('rect', {
        width: currentTime * 100 / duration + '%',
        height: '100%',
        opacity: '0.1'
      })
    ),
    children
  );
};

PositionMarker.propTypes = {
  currentTime: _propTypes2.default.number.isRequired,
  duration: _propTypes2.default.number.isRequired,
  children: _propTypes2.default.node
};

PositionMarker.defaultProps = {};

exports.default = (0, _connectToPlayer2.default)()(PositionMarker);