'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.EventTrack = exports.DetectorTrack = undefined;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _connectToPlayer = require('../connectToPlayer');

var _connectToPlayer2 = _interopRequireDefault(_connectToPlayer);

var _Occurrence = require('./Occurrence');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var mapStateToProps = function mapStateToProps(state) {
  return _extends({}, state, { duration: isNaN(state.duration) ? 0 : state.duration });
};

var DetectorTrack = function DetectorTrack(_ref) {
  var height = _ref.height;
  return _react2.default.createElement(
    'svg',
    { width: '100%', height: '16px' },
    _react2.default.createElement(
      'g',
      { style: { shapeRendering: 'crispEdges' } },
      _react2.default.createElement('line', { vectorEffect: 'non-scaling-stroke', strokeWidth: '1px', stroke: '#a0a0a0', x1: '0', x2: '100%', y1: '16', y2: '16' }),
      _react2.default.createElement('rect', { y: '10%', width: Math.random() * 100, height: '80%', rx: '3', ry: '3' })
    )
  );
};

var getNumbers = function getNumbers(duration, step) {
  var arr = [];
  for (var i = 0; i <= duration / step; i += 1) {
    arr.push(_react2.default.createElement(
      'text',
      {
        key: i,
        textAnchor: 'left',
        x: 100 * (i * step / duration) + 1 + '%',
        y: '12',
        style: { fontSize: '12px' }
      },
      new Date(i * step * 1000).toUTCString().split(' ')[4].substr(3)
    ));
  }
  return arr;
};

var EventTrack = function EventTrack(_ref2) {
  var duration = _ref2.duration;
  return _react2.default.createElement(
    'svg',
    { width: '100%' },
    _react2.default.createElement(
      'g',
      null,
      getNumbers(duration, duration / 10)
    ),
    _react2.default.createElement(
      'g',
      { style: { shapeRendering: 'crispEdges' } },
      _react2.default.createElement('line', { strokeWidth: '1px', stroke: '#868686', x1: '0', x2: '100%', y1: '15', y2: '15' })
    ),
    _react2.default.createElement('polygon', { points: '9,16 0,0 18,0', fill: '#89db50', style: { shapeRendering: 'optimizeQuality' } })
  );
};

var PlayerEventTrack = (0, _connectToPlayer2.default)(mapStateToProps)(EventTrack);

exports.DetectorTrack = DetectorTrack;
exports.EventTrack = PlayerEventTrack;

/*

    <PointOccurrence time={10} />
    <PointOccurrence time={121} />
    <PointOccurrence time={432} />
    <PointOccurrence time={521} />
    <PointOccurrence time={601} />
 */