'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Transcript = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _connectToPlayer = require('../connectToPlayer');

var _connectToPlayer2 = _interopRequireDefault(_connectToPlayer);

var _intervalTree1d = require('./interval-tree-1d');

var _intervalTree1d2 = _interopRequireDefault(_intervalTree1d);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var generateQueryFunctionFromWords = function generateQueryFunctionFromWords(words) {
  var wordIntervalsMap = words.reduce(function (word) {
    return words.set([word.s, word.e], word);
  }, new Map());
  var tree = _intervalTree1d2.default.apply(undefined, _toConsumableArray(wordIntervalsMap.entries));

  return function (intervals) {
    var matchingWords = intervals.reduce(function (acc, i) {
      return acc.concat(tree.query(i.start, i.end));
    }, []).reduce(function (acc, i) {
      return acc.set(wordIntervalsMap.get(i), new Set());
    });
    return [].concat(_toConsumableArray(matchingWords));
  };
};

/*
static renderWord(word, selections, prev, prevSelections, currentTime = 0) {
    if (selections.length || Math.max(word.s, currentTime * 1000) <= Math.min(word.e, (currentTime + 3) * 1000)) {
      return (
        <span
          key={word.p}
          style={Object.assign(
            {},
            ...selections.map(s => s.styles)),
            { background: '#aaa' }
          }
          className={selections.map(s => s.classes.join(' ')).join(' ')}
        >
          {includeSpace ? ' ' : ''}
          {word.w}
        </span>
      );
    }
    return (includeSpace ? ' ' : '') + word.w;
  }
 */

var Transcript = exports.Transcript = function (_React$Component) {
  _inherits(Transcript, _React$Component);

  function Transcript(props) {
    _classCallCheck(this, Transcript);

    var _this = _possibleConstructorReturn(this, (Transcript.__proto__ || Object.getPrototypeOf(Transcript)).call(this, props));

    _this.queryWords = generateQueryFunctionFromWords(props.words);
    return _this;
  }

  _createClass(Transcript, [{
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(newProps) {
      if (newProps.words !== this.props.words) {
        this.queryWords = generateQueryFunctionFromWords(this.props.words);
      }
    }
  }, {
    key: 'render',
    value: function render() {
      var _props = this.props,
          words = _props.words,
          groupingFunction = _props.groupingFunction,
          currentTime = _props.currentTime,
          selections = _props.selections;

      var selectionsForWord = words.reduce(function (acc, word) {
        return acc.set(word, selections.filter(function (selection) {
          return selection.intervals.some(function (s) {
            return Math.max(word.s, s.start) <= Math.min(word.e, s.end);
          });
        }));
      }, new Map());
      return _react2.default.createElement(
        'div',
        null,
        groupingFunction(words).map(function (line) {
          return _react2.default.createElement(
            'div',
            { key: line[0].p },
            line.reduce(function (acc, word, i, l) {
              acc.push(Transcript.renderWord(word, selectionsForWord.get(word), prev, prevSelections, currentTime));
              return acc;
            }, [])
          );
        })
      );
    }
  }]);

  return Transcript;
}(_react2.default.Component);

Transcript.propTypes = {
  words: _propTypes2.default.array.isRequired,
  currentTime: _propTypes2.default.number.isRequired,
  groupingFunction: _propTypes2.default.func,
  /*
  markup: PropTypes.arrayOf(PropTypes.shape({
    start: PropTypes.number.isRequired,
    end: PropTypes.number.isRequired,
    word: PropTypes.
    filter: PropTypes.func,
    style: PropTypes.object.isReqruied,
    className: PropTypes.string.isRequired,
  })),
  */
  entities: _propTypes2.default.arrayOf(_propTypes2.default.shape({
    template: _propTypes2.default.func.isRequired,
    channel: _propTypes2.default.func.isRequired,
    start: _propTypes2.default.number.isRequired,
    end: _propTypes2.default.number.isRequired
  }))
};
Transcript.defaultProps = {
  words: [],
  groupingFunction: function groupingFunction(words) {
    return words.length ? [words] : [];
  },
  selections: []
};
exports.default = (0, _connectToPlayer2.default)()(Transcript);