'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _Rx = require('rxjs/Rx');

var _playerConstants = require('./playerConstants');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function withPlayerInstance() {
  return function (WrappedComponent) {
    var _class, _temp;

    return _temp = _class = function (_React$Component) {
      _inherits(_class, _React$Component);

      function _class(props) {
        _classCallCheck(this, _class);

        var _this = _possibleConstructorReturn(this, (_class.__proto__ || Object.getPrototypeOf(_class)).call(this, props));

        _this.__instanceListeners = new Map();


        _this.__instanceStream = new _Rx.Subject().startWith(props.instance);

        _this.stateStream = _Rx.Observable.merge(_this.__instanceStream.switchMap(function (nextInstance) {
          return _Rx.Observable.merge.apply(_Rx.Observable, _toConsumableArray(_playerConstants.EVENTS.map(function (event) {
            return _Rx.Observable.fromEvent(nextInstance, event);
          })));
        }).startWith({})).map(function () {
          return {
            media: _playerConstants.PROPERTIES.reduce(function (acc, prop) {
              return Object.assign(acc, _defineProperty({}, prop, _this.props.instance[prop]));
            }, {}),
            analytics: {},
            ui: {}
          };
        });
        return _this;
      }

      _createClass(_class, [{
        key: 'getChildContext',
        value: function getChildContext() {
          return {
            __instanceStream: this.__instanceStream,
            stateStream: this.stateStream
          };
        }
      }, {
        key: 'componentWillReceiveProps',
        value: function componentWillReceiveProps(newProps) {
          var instance = this.props.instance;

          if (newProps.instance !== instance) {
            this.__instanceStream.next(newProps.instance);
          }
        }
      }, {
        key: 'render',
        value: function render() {
          // ... and renders the wrapped component with the fresh data!
          // Notice that we pass through any additional props
          return _react2.default.createElement(WrappedComponent, this.props);
        }
      }]);

      return _class;
    }(_react2.default.Component), _class.childContextTypes = {
      __instanceStream: _propTypes2.default.instanceOf(_Rx.Observable).isRequired,
      stateStream: _propTypes2.default.instanceOf(_Rx.Observable).isRequired
    }, _class.propTypes = {
      instance: _propTypes2.default.instanceOf(Element)
    }, _class.defaultProps = {
      instance: document.createElement('AUDIO'),
      channels: [],
      bookmarks: []
    }, _temp;
  };
}

exports.default = withPlayerInstance;