'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _redux = require('redux');

var _reactRedux = require('react-redux');

var _urlData = require('../redux/modules/urlData');

var _VoicebasePlayerCore = require('../components/VoicebasePlayerCore');

var _VoicebasePlayerCore2 = _interopRequireDefault(_VoicebasePlayerCore);

var _Spinner = require('../components/common/Spinner');

var _Spinner2 = _interopRequireDefault(_Spinner);

var _analyticsParser = require('../utilities/analytics-parser');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var mapStateToProps = function mapStateToProps(state) {
  var urlData = state.urlData;
  return {
    analytics: urlData.analytics,
    getAnalyticsPending: urlData.getAnalyticsPending,
    getAnalyticsError: urlData.getAnalyticsError
  };
};

var mapDispatchToProps = function mapDispatchToProps(dispatch) {
  return {
    updateAnalyticsUrl: (0, _redux.bindActionCreators)(_urlData.getUrlAnalytics, dispatch)
  };
};

var IntegratedUrlPlayer = function (_React$Component) {
  _inherits(IntegratedUrlPlayer, _React$Component);

  function IntegratedUrlPlayer() {
    _classCallCheck(this, IntegratedUrlPlayer);

    return _possibleConstructorReturn(this, (IntegratedUrlPlayer.__proto__ || Object.getPrototypeOf(IntegratedUrlPlayer)).apply(this, arguments));
  }

  _createClass(IntegratedUrlPlayer, [{
    key: 'componentWillMount',
    value: function componentWillMount() {
      var _props = this.props,
          analyticsUrl = _props.analyticsUrl,
          updateAnalyticsUrl = _props.updateAnalyticsUrl;

      updateAnalyticsUrl(analyticsUrl);
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps) {
      var _props2 = this.props,
          analyticsUrl = _props2.analyticsUrl,
          updateAnalyticsUrl = _props2.updateAnalyticsUrl;

      if (analyticsUrl !== nextProps.analyticsUrl) updateAnalyticsUrl(nextProps.analyticsUrl);
    }
  }, {
    key: 'render',
    value: function render() {
      var _props3 = this.props,
          getAnalyticsPending = _props3.getAnalyticsPending,
          analytics = _props3.analytics,
          analyticsFormat = _props3.analyticsFormat,
          mediaUrl = _props3.mediaUrl,
          rest = _objectWithoutProperties(_props3, ['getAnalyticsPending', 'analytics', 'analyticsFormat', 'mediaUrl']);
      // TODO: add states for errors or communicate to parent


      return _react2.default.createElement(
        'div',
        null,
        !getAnalyticsPending ? _react2.default.createElement(_VoicebasePlayerCore2.default, _extends({
          analytics: analytics,
          analyticsFormat: analyticsFormat,
          mediaUrl: mediaUrl
        }, rest)) : _react2.default.createElement(
          'div',
          { className: 'spinner-media_item' },
          _react2.default.createElement(_Spinner2.default, null)
        )
      );
    }
  }]);

  return IntegratedUrlPlayer;
}(_react2.default.Component);

IntegratedUrlPlayer.propTypes = {
  // Input Props
  analyticsUrl: _propTypes2.default.string.isRequired,
  analyticsFormat: _propTypes2.default.oneOf(_analyticsParser.AVAILABLE_ANALYTICS_SCHEMAS).isRequired,
  mediaUrl: _propTypes2.default.string.isRequired,

  // Mapped Props
  updateAnalyticsUrl: _propTypes2.default.func.isRequired,
  analytics: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.array]).isRequired,
  getAnalyticsPending: _propTypes2.default.bool.isRequired
  // TODO: Use these for errors in render or to communicate to parent
  // getAnalyticsError: PropTypes.objects,
};
IntegratedUrlPlayer.defaultProps = {
  analyticsFormat: _analyticsParser.ANALYTICS_SCHEMA_VERSION_V3
};
exports.default = (0, _reactRedux.connect)(mapStateToProps, mapDispatchToProps)(IntegratedUrlPlayer);