'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ANALYTICS_SCHEMA_VERSION_EVENT_STREAM = exports.ANALYTICS_SCHEMA_VERSION_V3 = exports.ANALYTICS_SCHEMA_VERSION_V2_CALLBACK = exports.ANALYTICS_SCHEMA_VERSION_V2 = exports.VoicebasePlayerCoreReducers = exports.CorePlayer = exports.IntegratedUrlPlayer = exports.StandaloneUrlPlayer = exports.IntegratedPlatformApiPlayer = exports.StandalonePlatformApiPlayer = undefined;

var _analyticsParser = require('./utilities/analytics-parser');

Object.defineProperty(exports, 'ANALYTICS_SCHEMA_VERSION_V2', {
  enumerable: true,
  get: function get() {
    return _analyticsParser.ANALYTICS_SCHEMA_VERSION_V2;
  }
});
Object.defineProperty(exports, 'ANALYTICS_SCHEMA_VERSION_V2_CALLBACK', {
  enumerable: true,
  get: function get() {
    return _analyticsParser.ANALYTICS_SCHEMA_VERSION_V2_CALLBACK;
  }
});
Object.defineProperty(exports, 'ANALYTICS_SCHEMA_VERSION_V3', {
  enumerable: true,
  get: function get() {
    return _analyticsParser.ANALYTICS_SCHEMA_VERSION_V3;
  }
});
Object.defineProperty(exports, 'ANALYTICS_SCHEMA_VERSION_EVENT_STREAM', {
  enumerable: true,
  get: function get() {
    return _analyticsParser.ANALYTICS_SCHEMA_VERSION_EVENT_STREAM;
  }
});

var _markers = require('./redux/modules/markers');

var _markers2 = _interopRequireDefault(_markers);

var _mediaData = require('./redux/modules/mediaData');

var _mediaData2 = _interopRequireDefault(_mediaData);

var _player = require('./redux/modules/player');

var _player2 = _interopRequireDefault(_player);

var _platformApiData = require('./redux/modules/platformApiData');

var _platformApiData2 = _interopRequireDefault(_platformApiData);

var _urlData = require('./redux/modules/urlData');

var _urlData2 = _interopRequireDefault(_urlData);

var _StandalonePlatformApiPlayer2 = require('./decorators/StandalonePlatformApiPlayer');

var _StandalonePlatformApiPlayer3 = _interopRequireDefault(_StandalonePlatformApiPlayer2);

var _IntegratedPlatformApiPlayer2 = require('./decorators/IntegratedPlatformApiPlayer');

var _IntegratedPlatformApiPlayer3 = _interopRequireDefault(_IntegratedPlatformApiPlayer2);

var _StandaloneUrlPlayer2 = require('./decorators/StandaloneUrlPlayer');

var _StandaloneUrlPlayer3 = _interopRequireDefault(_StandaloneUrlPlayer2);

var _IntegratedUrlPlayer2 = require('./decorators/IntegratedUrlPlayer');

var _IntegratedUrlPlayer3 = _interopRequireDefault(_IntegratedUrlPlayer2);

var _VoicebasePlayerCore = require('./components/VoicebasePlayerCore');

var _VoicebasePlayerCore2 = _interopRequireDefault(_VoicebasePlayerCore);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Public reducers for integrated versions of the player
 */
exports.StandalonePlatformApiPlayer = _StandalonePlatformApiPlayer3.default;

/**
 * Decorators and standardised implementations of the player
 */

exports.IntegratedPlatformApiPlayer = _IntegratedPlatformApiPlayer3.default;
exports.StandaloneUrlPlayer = _StandaloneUrlPlayer3.default;
exports.IntegratedUrlPlayer = _IntegratedUrlPlayer3.default;

/**
 * Core player for custom implementations where a decorator isn't required
 */

exports.CorePlayer = _VoicebasePlayerCore2.default;

/**
 * Redux related exports for integrated players
 */

var VoicebasePlayerCoreReducers = exports.VoicebasePlayerCoreReducers = {
  markers: _markers2.default,
  mediaData: _mediaData2.default,
  player: _player2.default,
  platformApiData: _platformApiData2.default,
  urlData: _urlData2.default
};

/**
 * We export AVAILABLE schema versions as they are used as input variables.
 */