'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initialState = exports.actions = exports.clearJustCreatedMarkers = exports.setMarkers = exports.CLEAR_JUST_CREATED_MARKERS = exports.SET_MARKERS = undefined;

var _handleActions;

var _reduxActions = require('redux-actions');

var _Normalize = require('../../common/Normalize');

var _Common = require('../../common/Common');

var _immutable = require('immutable');

var Immutable = _interopRequireWildcard(_immutable);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Constants
 * */
var SET_MARKERS = exports.SET_MARKERS = 'SET_MARKERS';
var CLEAR_JUST_CREATED_MARKERS = exports.CLEAR_JUST_CREATED_MARKERS = 'CLEAR_JUST_CREATED_MARKERS';

/*
 * Actions
 * */
var setMarkers = exports.setMarkers = (0, _reduxActions.createAction)(SET_MARKERS, function (markers) {
  return markers;
});
var clearJustCreatedMarkers = exports.clearJustCreatedMarkers = (0, _reduxActions.createAction)(CLEAR_JUST_CREATED_MARKERS);

var actions = exports.actions = {
  setMarkers: setMarkers,
  clearJustCreatedMarkers: clearJustCreatedMarkers
};

/*
 * State
 * */
var initialState = exports.initialState = new Immutable.Map({
  markerIds: new Immutable.List(),
  markers: new Immutable.Map(),
  justCreated: false
});

/*
 * Reducers
 * */
exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, SET_MARKERS, function (state, _ref) {
  var _markers = _ref.payload;

  var markers = _markers.sort((0, _Common.sortByField)('time'));
  var result = (0, _Normalize.normalize)(markers, function (marker, i) {
    return {
      id: i.toString(),
      time: marker.time,
      keywordName: marker.keywordName,
      color: marker.color
    };
  });

  return state.merge({
    markerIds: result.ids,
    markers: result.entities,
    justCreated: true
  });
}), _defineProperty(_handleActions, CLEAR_JUST_CREATED_MARKERS, function (state) {
  return state.set('justCreated', false);
}), _handleActions), initialState);