'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.actions = exports.getPlatformApiMediaUrl = exports.getPlatformApiAnalytics = exports.initialState = exports.GET_PLATFORM_API_MEDIA_URL = exports.GET_PLATFORM_API_ANALYTICS = undefined;

var _handleActions;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reduxActions = require('redux-actions');

var _mediaApi = require('../../api/mediaApi');

var _mediaApi2 = _interopRequireDefault(_mediaApi);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Constants
 * */
var GET_PLATFORM_API_ANALYTICS = exports.GET_PLATFORM_API_ANALYTICS = 'GET_PLATFORM_API_ANALYTICS';
var GET_PLATFORM_API_MEDIA_URL = exports.GET_PLATFORM_API_MEDIA_URL = 'GET_PLATFORM_API_MEDIA_URL';

/**
 * State
 */
var initialState = exports.initialState = {
  analytics: {},
  mediaUrl: '',
  getAnalyticsPending: true,
  getAnalyticsError: '',
  getMediaUrlPending: true,
  getMediaUrlError: ''
};

/**
 * Actions
 */
var getPlatformApiAnalytics = exports.getPlatformApiAnalytics = function getPlatformApiAnalytics(token, mediaId) {
  return function (dispatch) {
    return dispatch({
      type: GET_PLATFORM_API_ANALYTICS,
      payload: {
        data: {
          token: token,
          mediaId: mediaId
        },
        promise: _mediaApi2.default.getDataForMedia(token, mediaId)
      }
    });
  };
};

var getPlatformApiMediaUrl = exports.getPlatformApiMediaUrl = (0, _reduxActions.createAction)(GET_PLATFORM_API_MEDIA_URL, function (token, mediaId) {
  return {
    data: {
      mediaId: mediaId
    },
    promise: _mediaApi2.default.getMediaUrl(token, mediaId)
  };
});

var actions = exports.actions = {
  getPlatformApiAnalytics: getPlatformApiAnalytics,
  getPlatformApiMediaUrl: getPlatformApiMediaUrl
};

/**
 * Reducers
 */
exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, GET_PLATFORM_API_ANALYTICS + '_PENDING', function undefined(state) {
  return _extends({}, state, {
    getAnalyticsPending: true
  });
}), _defineProperty(_handleActions, GET_PLATFORM_API_ANALYTICS + '_REJECTED', function undefined(state, _ref) {
  var payload = _ref.payload;
  return _extends({}, state, {
    getAnalyticsPending: false,
    getAnalyticsError: payload.error
  });
}), _defineProperty(_handleActions, GET_PLATFORM_API_ANALYTICS + '_FULFILLED', function undefined(state, _ref2) {
  var response = _ref2.payload;
  return _extends({}, state, {
    analytics: response,
    getAnalyticsPending: false,
    getAnalyticsError: ''
  });
}), _defineProperty(_handleActions, GET_PLATFORM_API_MEDIA_URL + '_PENDING', function undefined(state) {
  return _extends({}, state, {
    getMediaUrlPending: true
  });
}), _defineProperty(_handleActions, GET_PLATFORM_API_MEDIA_URL + '_REJECTED', function undefined(state, _ref3) {
  var payload = _ref3.payload;
  return _extends({}, state, {
    getMediaUrlPending: false,
    getMediaUrlError: payload.error
  });
}), _defineProperty(_handleActions, GET_PLATFORM_API_MEDIA_URL + '_FULFILLED', function undefined(state, _ref4) {
  var payload = _ref4.payload;
  return _extends({}, state, {
    mediaUrl: payload.url,
    getMediaUrlPending: false,
    getMediaUrlError: ''
  });
}), _handleActions), initialState);