'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.initialState = exports.actions = exports.setSearchIdentifiedRanges = exports.setSearchCurrentInputTerm = exports.SET_SEARCH_IDENTIFIED_RANGES = exports.SET_SEARCH_CURRENT_INPUT_TERM = undefined;

var _handleActions;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reduxActions = require('redux-actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Constants
 * */
var SET_SEARCH_CURRENT_INPUT_TERM = exports.SET_SEARCH_CURRENT_INPUT_TERM = 'SET_SEARCH_CURRENT_INPUT_TERM';
var SET_SEARCH_IDENTIFIED_RANGES = exports.SET_SEARCH_IDENTIFIED_RANGES = 'SET_SEARCH_IDENTIFIED_RANGES';

/*
 * Actions
 */
var setSearchCurrentInputTerm = exports.setSearchCurrentInputTerm = (0, _reduxActions.createAction)(SET_SEARCH_CURRENT_INPUT_TERM, function (currentInputTerm) {
  return currentInputTerm;
});
var setSearchIdentifiedRanges = exports.setSearchIdentifiedRanges = (0, _reduxActions.createAction)(SET_SEARCH_IDENTIFIED_RANGES, function (identifiedRanges) {
  return identifiedRanges;
});

var actions = exports.actions = {
  setSearchCurrentInputTerm: setSearchCurrentInputTerm,
  setSearchIdentifiedRanges: setSearchIdentifiedRanges
};

/*
 * State
 * */
var initialState = exports.initialState = {
  currentInputTerm: '',
  identifiedRanges: []
};

/*
 * Reducers
 * */
exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, SET_SEARCH_CURRENT_INPUT_TERM, function (state, _ref) {
  var currentInputTerm = _ref.payload;
  return _extends({}, state, {
    currentInputTerm: currentInputTerm
  });
}), _defineProperty(_handleActions, SET_SEARCH_IDENTIFIED_RANGES, function (state, _ref2) {
  var identifiedRanges = _ref2.payload;
  return _extends({}, state, {
    identifiedRanges: identifiedRanges
  });
}), _handleActions), initialState);