'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.actions = exports.getUrlAnalytics = exports.initialState = exports.GET_URL_ANALYTICS = undefined;

var _handleActions;

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _reduxActions = require('redux-actions');

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

/*
 * Constants
 * */
var GET_URL_ANALYTICS = exports.GET_URL_ANALYTICS = 'GET_URL_ANALYTICS';

/**
 * State
 */
var initialState = exports.initialState = {
  analytics: {},
  getAnalyticsPending: true,
  getAnalyticsError: ''
};

/**
 * Actions
 */
var getUrlAnalytics = exports.getUrlAnalytics = function getUrlAnalytics(url) {
  return function (dispatch) {
    return dispatch({
      type: GET_URL_ANALYTICS,
      payload: {
        data: {
          url: url
        },
        promise: fetch(url).then(function (response) {
          return response.json();
        })
      }
    });
  };
};

var actions = exports.actions = {
  getUrlAnalytics: getUrlAnalytics
};

/**
 * Reducers
 */
exports.default = (0, _reduxActions.handleActions)((_handleActions = {}, _defineProperty(_handleActions, GET_URL_ANALYTICS + '_PENDING', function undefined(state) {
  return _extends({}, state, {
    getAnalyticsPending: true
  });
}), _defineProperty(_handleActions, GET_URL_ANALYTICS + '_REJECTED', function undefined(state, _ref) {
  var payload = _ref.payload;
  return _extends({}, state, {
    getAnalyticsPending: false,
    getAnalyticsError: payload.error
  });
}), _defineProperty(_handleActions, GET_URL_ANALYTICS + '_FULFILLED', function undefined(state, _ref2) {
  var response = _ref2.payload;
  return _extends({}, state, {
    analytics: response,
    getAnalyticsPending: false,
    getAnalyticsError: ''
  });
}), _handleActions), initialState);